c 
c w_edit03.for
c ============
c
c call back functions and subroutines for simfit editor help
c
c 1) ishow_formats
c 2) show_file_formats
c 3) itellthem_all
c
c
      recursive integer function ishow_formats()
      implicit none
      external show_file_formats
      ishow_formats = 1
      call show_file_formats
      end
c
c
      recursive subroutine show_file_formats
c     03/10/2010 replaced x_vutxt by help_formats
      implicit   none
      integer    nmax
      parameter (nmax = 30)
      integer    icolor, ix, iy, lshade, numdec, numopt, ntext
      parameter (icolor = 9, ix = 4, iy = 4, lshade = 1, numopt = 13)
      integer    numbld(nmax), numpos(numopt)
      character (len = 100) text(nmax)
      logical    repeet, border
      parameter (border = .false.)
      external   x_lbox02, w_patch1, help_formats
      data       numbld / nmax*0 /
      data       numpos / numopt*1 /
      repeet = .true.
      do while (repeet)
         write (text,100)
         numdec = numopt - 1
         call x_lbox02 (icolor, ix, iy, numdec, numopt, numpos, 
     +                  text)
         if (numdec.eq.1) then
            write (text,200)
            ntext = 20
            numbld(1) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
         elseif (numdec.eq.2) then
            write (text,300)
            ntext = 20
            numbld(1) = 1
            numbld(16) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
            numbld(16) = 0
         elseif (numdec.eq.3) then
            write (text,400)
            ntext = 20
            numbld(1) = 1
            numbld(7) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
            numbld(7) = 0
         elseif (numdec.eq.4) then
            write (text,500)
            ntext = 22
            numbld(1) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext, 
     +                     text,
     +                     border)
            numbld(1) = 0
         elseif (numdec.eq.5) then
            write (text,600)
            ntext = 20
            numbld(1) = 1
            numbld(6) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
            numbld(6) = 0
         elseif (numdec.eq.6) then
            write (text,700)
            ntext = 20
            numbld(1) = 1
            numbld(8) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
            numbld(8) = 0
         elseif (numdec.eq.7) then
            write (text,800)
            ntext = 20
            numbld(1) = 1
            numbld(8) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
            numbld(8) = 0
         elseif (numdec.eq.8) then
            write (text,900)
            ntext = 20
            numbld(1) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
         elseif (numdec.eq.9) then
            write (text,1000)
            ntext = 12
            numbld(1) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
         elseif (numdec.eq.10) then
            write (text,1100)
            ntext = 20
            numbld(1) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
         elseif (numdec.eq.11) then
            call help_formats ('formats')
         elseif (numdec.eq.numopt - 1) then
            write (text,1200)
            ntext = 22
            numbld(1) = 1
            call w_patch1 (icolor, ix, iy, lshade, numbld, ntext,
     +                     text,
     +                     border)
            numbld(1) = 0
         elseif (numdec.eq.numopt) then
            repeet = .false.
         endif
      enddo  
c
c format statements
c      
  100 format (
     + 'Curve fitting'
     +/'Statistics'
     +/'Simple plots'
     +/'Error bar plots'
     +/'Simple pie charts'
     +/'Advanced pie charts'
     +/'Simple bar charts'
     +/'Advanced bar charts'
     +/'Fill styles'
     +/'Colours'
     +/'Examples'
     +/'Help'
     +/'Quit ... Exit format details procedure')
  200 format ('The format for curve fitting files (2 or 3 columns)'
     +/
     +/'Column 1 = the independent variable (x)'
     +/'Column 2 = the dependent variable (y)'
     +/'If a third column is present it will contain weighting'
     +/'factors s > 0 (i.e. standard deviations of y).'
     +/
     +/'Usually x must be in increasing order, since differential'
     +/'equations are solved iteratively from x(i) to x(i + 1),'
     +/'starting estimates use the first and last points for boot-'
     +/'strapping, plots look best with x joined sequentially and'
     +/'data sets are not ordered automatically, since that may cause'
     +/'you to overlook a typing error. Program Editfl can be used'
     +/'to put random x-values into order and program Qnfit can be'
     +/'used with un-ordered data (if that is what you want).'
     +/'The editor may force you to edit x in increasing order.'
     +/
     +/'The s-values (where w = 1/s^2) may be missing altogether or'
     +/'equivalently all set to s = 1.'
     +/'The editor may force you to provide positive s-values.')
  300 format ('The format for statistics files (1 or n columns)'
     +/
     +/'Vector files have just one column and they are required'
     +/'by program Simstat for exhaustive analysis of a sample,'
     +/'and 1-sample Kolmogorov-Smirnov tests. Two vectors are'
     +/'required for t, Mann-Whitney-U tests and Kolmogorov-Smirnov'
     +/'2-sample tests, and vectors are also used for predicting'
     +/'from calibration curves.'
     +/
     +/'Matrix files have an array of data and they are required for'
     +/'correlation analysis or analysis of variance. Note that Simfit'
     +/'will not accept missing values. You have to choose the method'
     +/'required to replace missing values by estimates or to delete'
     +/'them alltogether and you must supply a full matrix of values.'
     +/
     +/'Library files'
     +/'For most statistics and plotting options that require sequences'
     +/'of files it is best to prepare the individual vector, matrix,'
     +/'curve fitting or plotting files that are required. Then make a'
     +/'library file to supply them all at once.')
  400 format ('The format for plotting files (2 or 3 columns)'
     +/
     +/'Column 1 = the x values'
     +/'Column 2 = the y values'
     +/'Column 3 (if present) is ignored by plotting programs'
     +/
     +/'Advice about using plotting files in program Simplot'
     +/'1.`The (x,y) pairs in a plotting file can be identified by'
     +/'  `symbols and/or joined up by lines.'
     +/'2.`You can select the symbol/line-type/line-thickness/colour'
     +/'  `using the Data options.'
     +/'3.`Points are joined up by lines in the order of the x-values'
     +/'  `in the file.'
     +/'4.`Although you can type in data interactively this is not the'
     +/'  `correct way to create (x,y) plotting files. You should use'
     +/'  `curve-fitting files as plotting files and save the best-fit'
     +/'  `curves as ASCII coordinate files from the Simfit fitting'
     +/'  `programs.'
     +/'5.`Use libary files to supply sets of files simultaneously. For'
     +/'  `an example study the test library file simfig1.tfl.')
  500 format ('The format for error bar files (4 or 6 columns)'
     +/
     +/'Column 1 = the x values'
     +/'Column 2 = the low error bar values'
     +/'Column 3 = the mean y-values'
     +/'Column 4 = the high error bar values'
     +/
     +/'1.`Error bars can be calculated interactively from replicates'
     +/'  `in Simplot but you can make an error bar file by reading the'
     +/'  `data with all replicates into program Editfl to calculate'
     +/'  `mean y-values and error bars, at say 95% confidence limits.'
     +/'2.`If you type in interactively then the error bars can have'
     +/'  `any meaning, e.g. 2 standard deviations. Low bars higher'
     +/'  `than the mean or high bars less than the mean will be re-set'
     +/'  `to the mean values.'
     +/'3.`Error bars are transformed automatically if you transform'
     +/'  `data so, of course, the transformed error bars will not be'
     +/'  `symmetrical, e.g. in a log/log or Scatchard plot.'
     +/'4.`Plot then study test file errorbar.tf1 for 4 column format'
     +/'5.`Plot then study test file errorbar.tf2 for 6 column format'
     +/'  `which is required for asymmetrical, slanting or multiple'
     +/'  `error bars.')
  600 format ('The format for simple pie charts (1 column)'
     +/
     +/'Column 1 = the no. of items in the corresponding segment'
     +/'i.e., a (short)  vector of positive numbers.'
     +/
     +/'Advice about creating pie charts using program Simplot'
     +/'1.`Segment numbers must be > 0.'
     +/'3.`Simplot accepts simple pie chart data in the above format'
     +/'  `directly from vector files or by typing data interactively.'
     +/'4.`When Simplot accepts simple pie chart data from keyboard or'
     +/'  `file it will check the values and then create an advanced'
     +/'  `pie chart file with extra arguments for width, colour and'
     +/'  `segment displacement factors. The default values for these'
     +/'  `can be set using the configuration options.'
     +/'5 `You can alter any segment or associated label using the Data'
     +/'  `option but these will only be written to file if you select'
     +/'  `Save from the Data option to save an advanced piechart file.'
     +/'6.`The best way to make pie charts is to read in a vector, edit'
     +/'  `as required, then save the advanced pie chart file and the'
     +/'  `corresponding cfg file needed to re-create the graph.')
  700 format ('The format for advanced pie chart files (4 columns)'
     +/
     +/'Column 1 = the no. of items in the corresponding segment'
     +/'Column 2 = the fill style required for the segment [0,10]'
     +/'Column 3 = the displacement of the segment [0,1]'
     +/'Column 4 = the colour index for the segment [0,71]'
     +/
     +/'Advice about using advanced pie chart files in program Simplot'
     +/
     +/'1.`Pie chart segment numbers must be > 0. Simplot normalises'
     +/'  `these values into proportions to calculate rotation angles.'
     +/'2.`Fill styles must be a number between 0 and 10.'
     +/'3.`Displacements detach and displace the segment centrifugally.'
     +/'4.`Colours must be between 0 and 71, i.e. as in the palette.'
     +/'5.`Segments are numbered in order of increasing angle in the'
     +/'  `mathematical sense, i.e. anticlockwise.'
     +/'6.`The fill style and colour code can be read off any advanced'
     +/'  `pie chart test file, e.g. piechart.tf1.'
     +/'7.`The way labels can be supplied will also be clear from the'
     +/'  `test files, but you can supply these interactively.')
  800 format ('The format for simple bar charts'
     +/
     +/'The data are formatted as a m by n matrix of positive values.'
     +/'The number of rows (m) is the number of groups of bars.'
     +/'The number of columns (n) is the number of bars per group'
     +/'The total number of bars plotted is m multiplied by n.'
     +/
     +/'Advice about creating bar charts using program Simplot'
     +/'1.`Simplot accepts such matrix data from files or the keyboard.'
     +/'2.`If you input such matrix data then Simplot will add extra'
     +/'  `arguments and create an advanced bar chart file.'
     +/'3.`After such a file is prepared in Simplot you should alter'
     +/'  `the fill style, labels and colours, interactively using'
     +/'  `the Data then Symbols options, not the numeric file editing.'
     +/'4.`After interactive editing the edited data can be saved as'
     +/'  `an advanced bar chart file and related cfg file.'
     +/'5.`You can also prepare a m by n matrix of corresponding errors'
     +/'  `to be used to generate error bars. For instance, if the data'
     +/'  `are sample means the errors could be t(nu)*(std.err.mean) to'
     +/'  `put error bars at 95% confidence limit, etc.')
  900 format ('The format for advanced bar chart files (9 columns)'
     +/
     +/'Column 1 = the x values'
     +/'Column 2 = y1, the lowest error bar'
     +/'Column 3 = y2, the bottom of the bar'
     +/'Column 4 = y3, the median of the bar'
     +/'Column 5 = y4, the top of the bar'
     +/'Column 6 = y5, the upper error bar'
     +/'Column 7 = f, the bar fill style (0-10)'
     +/'Column 8 = w, the bar width (0-1)'
     +/'Column 9 = c, the bar colour (0-71)'
     +/
     +/'Such files are rather complicated to edit but they do have the'
     +/'advantage that you can have bars with arbitrary positions,'
     +/'heights, error bars, widths, colours, fill styles, etc.'
     +/'Because of the versatility of this format you can mix together'
     +/'groups, stacks, overlapping bars, etc. on the same graph or you'
     +/'can have bar and whisker symbols. The best way to appreciate'
     +/'the scope is to plot the bar chart test files barchart.tf?'
     +/'provided then browse them in the Simfit viewer.')
 1000 format ('Fill styles (f) for pie and bar chart files'
     +/
     +/'f = 0    `no display'
     +/'f = 1    `empty'
     +/'f = 2    `solid'
     +/'f = 3    `upward diagonals'
     +/'f = 4    `downward diagonals'
     +/'f = 5    `criss cross'
     +/'f = 6    `horizontal'
     +/'f = 7    `vertical'
     +/'f = 8    `dashes'
     +/'f = 9    `dots'
     +/'f = 10   `dots-dashes')
 1100 format ('Colours (c) for pie and bar chart files'
     +/'c = 0    `Black'
     +/'c = 1    `Blue'
     +/'c = 2    `Green'
     +/'c = 3    `Cyan'
     +/'c = 4    `Red'
     +/'c = 5    `Magenta'
     +/'c = 6    `Brown'
     +/'c = 7    `White'
     +/'c = 8    `Dark Gray'
     +/'c = 9    `Light Blue'
     +/'c = 10   `Light Green'
     +/'c = 11   `Light Cyan'
     +/'c = 12   `Light Red'
     +/'c = 13   `Light Magenta'
     +/'c = 14   `Yellow'
     +/'c = 15   `Intense White'
     +/' ...     `etc.'
     +/' ...     `etc.'
     +/'c = 71   `etc. (see w_ps.cfg)')
 1200 format ('The Simfit data file format'
     +/
     +/'Simfit data files for nm data values are ASCII text files'
     +/'with n + 2 or n + k + 3 lines as now described. Library files'
     +/'just have a title followed by a list of data filenames. Simfit'
     +/'data files can be formatted and edited by Simfit editors, read'
     +/'in from the clipboard, or written out by spreadsheets.'
     +/
     +/'Line 1: title for the data (=< 80 characters)'
     +/'Line 2: n (no. rows) m (no. columns)'
     +/'Line 3: datum(1,1) datum(1,2) datum(1,3) ... datum(1,m)'
     +/'Line 4: datum(2,1) datum(2,2) datum(2,3) ... datam(2,m)'
     +/'...'
     +/'...'
     +/'...'
     +/'Line n + 2: datum(n,1) datum(n,2) datum(n,3) ... datum(n,m)'
     +/'Line n + 3: k (no. extra lines...optional)'
     +/'Line n + 4: extra line 1'
     +/'Line n + 5: extra line 2'
     +/'...'
     +/'...'
     +/'Line n + k + 3: extra line k')
       end
c
c
      recursive integer function itellthem_all ()
      implicit   none
      integer    icolor, n0, n1, numtxt
      parameter (icolor = 9, n0 = 0, n1 = 1)
      integer    numbld(30)
      character (len = 100) text(30)
      logical    frame, next, updown
      parameter (frame = .false., updown = .true.)
      external   x_tutor1
      itellthem_all =  n1
c...1
      numtxt = n1
      text(numtxt) = 'The Simfit editor'
      numbld(numtxt) = n1
c...2
      numtxt = numtxt + n1
      text(numtxt) = 'The editor has several modes, each with'
     +//' dedicated functions to facilitate data handling in Simfit.'
      numbld(numtxt) = n0
c...3
      numtxt = numtxt + n1
      text(numtxt) = 'Viewing mode'
      numbld(numtxt) = n1
c...4
      numtxt = numtxt + n1
      text(numtxt) = 'In this mode you can scroll thorough the data'
     +//' set but you cannot make any alterations.'
      numbld(numtxt) = n0
c...5
      numtxt = numtxt + n1
      text(numtxt) = 'Editing mode'
      numbld(numtxt) = n1
c...6
      numtxt = numtxt + n1
      text(numtxt) = 'Use the scroll bars or, the'
     +//' mouse to select cells for editing.'
      numbld(numtxt) = n0
c...7
      numtxt = numtxt + n1
      text(numtxt) = 'Improper numbers such as 1O or 1o instead of'
     +//' 10 for ten are rejected.'
      numbld(numtxt) = n0
c...8
      numtxt = numtxt + n1
      text(numtxt) = 'Creating mode'
      numbld(numtxt) = n1
c...9
      numtxt = numtxt + n1
      text(numtxt) = 'You fill in empty cells in sequential order so'
     +//' numbers can be checked for consistency.'
      numbld(numtxt) = n0
c...10
      numtxt = numtxt + n1
      text(numtxt) = 'When finished you can scroll and edit normally.'
      numbld(numtxt) = n0
c...11
      numtxt = numtxt + n1
      text(numtxt) = 'Simfit programs using this editor'
      numbld(numtxt) = n1
c...12
      numtxt = numtxt + n1
      text(numtxt) = 'MAKFIL/EDITFL are for curve fitting files and'
     +//' MAKMAT/EDITMT for matrix and vector files.'
      numbld(numtxt) = n0
c...13
      numtxt = numtxt + n1
      text(numtxt) = 'Additional Functions'
      numbld(numtxt) = n1
c...14
      numtxt = numtxt + n1
      text(numtxt) = 'CF refers to curve fitting and MV to'
     +//' matrix/vector data files.'
      numbld(numtxt) = n0
c...15
      numtxt = numtxt + n1
      text(numtxt) = 'Order (CF)       `makes sure values in column 1'
     +//' are in increasing order for plotting/fitting.'
      numbld(numtxt) = n0
c...16
      numtxt = numtxt + n1
      text(numtxt) = 'Weight (CF)      `makes sure values in column 3'
     +//' are suitable for weights in fitting.'
      numbld(numtxt) = n0
c...17
      numtxt = numtxt + n1
      text(numtxt) = 'Insert (CF/MV)   `creates a new row or column,'
     +//' so enlarging the data set.'
      numbld(numtxt) = n0
c...18
      numtxt = numtxt + n1
      text(numtxt) = 'Delete (CF/MV)   `deletes a row or column,'
     +//' so diminishing the data set.'
      numbld(numtxt) = n0
c...19
      numtxt = numtxt + n1 
      text(numtxt) = 'Swap (MV)        `interchanges rows or columns.'
      numbld(numtxt) = n0
c...20
      numtxt = numtxt + n1
      text(numtxt) = 'Move (MV)        `moves rows/columns from one'
     +//' position to another position, i.e. rolls.'
      numbld(numtxt) = n0
c...21
      numtxt = numtxt + n1
      text(numtxt) = 'Fix (MV)         `sets a complete row or column'
     +//' equal to a fixed value.'
      numbld(numtxt) = n0
c...22
      numtxt = numtxt + n1
      text(numtxt) = 'Change (MV)      `transforms a complete row or'
     +//' column.'
      numbld(numtxt) = n0
c...23
      numtxt = numtxt + n1
      text(numtxt) = 'Calculate (MV)   `Performs arithmetic with all'
     +//' numbers in a row or column.'
      numbld(numtxt) = n0
c...24
      numtxt = numtxt + n1
      text(numtxt) = 'Cut/paste (MV)   `inputs/outputs rows/columns'
     +//' or selected blocks of data to/from buffers.'
      numbld(numtxt) = n0
      next = .true.
      call x_tutor1 (icolor, numbld, numtxt, text, frame, next, updown)
c...1
      numtxt = n1
      text(numtxt) = 'Formatting'
      numbld(numtxt) = n1
c...2
      numtxt = numtxt + n1
      text(numtxt) = 'The editor uses integers where appropriate'
     +//' (Fisher-exact/Chi-square tests) but exponential'
      numbld(numtxt) = n0
c...3
      numtxt = numtxt + n1
      text(numtxt) = 'notation is used for very large or small'
     +//' floating point numbers (to facilitate checking tables'
      numbld(numtxt) = n0
c...4
      numtxt = numtxt + n1
      text(numtxt) = 'for orders of magnitude or significant figures).'
     +//' So 1.1E-02 means 0.011, while 1.1E+02 is 110.'
      numbld(numtxt) = n0
c...5
      numtxt = numtxt + n1
      text(numtxt) = 'Note that -1.000-200 is minus one multiplied by'
     +//' ten to the minus two hundred, while the reading'
      numbld(numtxt) = n0
c...6
      numtxt = numtxt + n1
      text(numtxt) = 'frame eliminates blanks, so that 1   2   3 is'
     +//' interpreted as 123.'
      numbld(numtxt) = n0
c...7
      numtxt = numtxt + n1
      text(numtxt) = 'Examples: 1+1 = 10, 1-1 = 0.1, 1e2 = 100'
     +//', 1e-2 = 0.01, 1+6 = 1000000, 1.0E+03 = 1000.'
      numbld(numtxt) = n0
c...8
      numtxt = numtxt + n1
      text(numtxt) = 'Using Creating mode'
      numbld(numtxt) = n1
c...9
      numtxt = numtxt + n1
      text(numtxt) = 'When you enter this mode you will be confronted'
     +//' by a set of blank cells. After entering a number'
      numbld(numtxt) = n0
c...10
      numtxt = numtxt + n1
      text(numtxt) = 'the focus has to be moved to the next cell,'
     +//' which must be sequential for x in curve fitting data.'
      numbld(numtxt) = n0
c...11
      numtxt = numtxt + n1
      text(numtxt) = 'You can use commas or decimal points for'
     +//' floating point numbers (for example 1,234 = 1.234).'
      numbld(numtxt) = n0
c...12
      numtxt = numtxt + n1
      text(numtxt) = 'When all cells have been filled you can'
     +//' scroll and edit anywhere. For advanced editing such as'
      numbld(numtxt) = n0
c...13
      numtxt = numtxt + n1
      text(numtxt) =  'deleting/inserting new rows/columns etc. use'
     +//'  programs EDITFL (curve fitting) or EDITMT (vectors and'
      numbld(numtxt) = n0
c...14
      numtxt = numtxt + n1
      text(numtxt) =  'matrices) since'
     +//' dimensions cannot be changed in this editor.'
      numbld(numtxt) = n0
c...15
      numtxt = numtxt + n1
      text(numtxt) = 'Unfinished data sets'
      numbld(numtxt) = n1
c...16
      numtxt = numtxt + n1
      text(numtxt) = 'If you exit before all cells are completed the'
     +//' editor will set all uncompleted cells equal to one.'
      numbld(numtxt) = n0
c...17
      numtxt = numtxt + n1
      text(numtxt) = 'Large data sets'
      numbld(numtxt) = n1
c...18
      numtxt = numtxt + n1
      text(numtxt) = 'If the data set is too large to read into the'
     +//' editor you choose an offset (i.e. top left corner).'
      numbld(numtxt) = n0
c...19
      numtxt = numtxt + n1
      text(numtxt) = 'Consistent functions'
      numbld(numtxt) = n1
c...20
      numtxt = numtxt + n1
      text(numtxt) = 'The editor decides which functions you can'
     +//' use and this depends on the application calling'
      numbld(numtxt) = n0
c...21
      numtxt = numtxt + n1
      text(numtxt) = 'the editor. For instance, Order and Weight are'
     +//' always switched on when editing curve fitting'
      numbld(numtxt) = n0
c...22
      numtxt = numtxt + n1
      text(numtxt) = 'files, while operations that would alter the'
     +//' data set dimensions are always switched off in'
      numbld(numtxt) = n0
c...23
      numtxt = numtxt + n1
      text(numtxt) = 'the Creation mode.'
      numbld(numtxt) = n0
      next = .false.
      call x_tutor1 (icolor, numbld, numtxt, text, frame, next, updown)
      end
c
c
