c
c
      subroutine x_gkstic (isend, nxtic, nytic)
c
c action: set number of tick intervals (i.e. tick marks - 1) for simple graphics
c author: w.g.bardsley, university of manchester, u.k., 21/07/2009
c
      implicit none
c
c arguments
c      
      integer, intent (in)    :: isend
      integer, intent (inout) :: nxtic, nytic
c
c locals
c      
      integer    ival(2), nxsav, nysav
      integer    n, nbot, nmid, ntop
      parameter (n = 2, nbot = 1, nmid = 4, ntop = 9)
      character  text(n)*100, iwarnu*100
      logical    loop, ok_x, ok_y
      external   x_geti0n, x_putfat
      save       nxsav, nysav
      data       nxsav, nysav / nmid, nmid /
      if (isend.eq.1) then
c
c set storage values directly
c        
         nxsav = nxtic
         nysav = nytic
         if (nxsav.lt.nbot .or. nxsav.gt.ntop) nxsav = nmid
         if (nysav.lt.nbot .or. nysav.gt.ntop) nysav = nmid
      elseif (isend.eq.2) then
c
c set storage values 
c      
         if (nxsav.lt.nbot .or. nxsav.gt.ntop) nxsav = nmid
         if (nysav.lt.nbot .or. nysav.gt.ntop) nysav = nmid
         ival(1) = nxsav 
         ival(2) = nysav 
         write (text,100)
         loop = .true.
         do while (loop)
            ok_x = .false.
            ok_y = .false.
            call x_geti0n (n, ival,
     +                     text)
            if (ival(1).ge.nbot .and. ival(1).le.ntop) ok_x = .true.
            if (ival(2).ge.nbot .and. ival(2).le.ntop) ok_y = .true.
            if (ok_x .and. ok_y) then
               loop = .false.
            else
               write (iwarnu,200)
               call x_putfat (iwarnu)
            endif     
         enddo 
         nxsav = ival(1)
         nysav = ival(2)
         nxtic = nxsav
         nytic = nysav 
      else
c
c retrieve storage values
c        
         nxtic = nxsav
         nytic = nysav
      endif
c
c format statement
c      
  100 format (
     + 'Number of x tick intervals (i.e. tick marks - 1)'
     +/'Number of y tick intervals (i.e. tick marks - 1)')    
  200 format ('Must have  1 =< number of tick intervals =< 9')   
      end       