C
C
      SUBROUTINE CONBBB$(ICOLOR, ITHETA, NOUT_PS, Y_SCALE, ARRAYX,
     +                   ARRAYY, XTITLE, YTITLE,
     +                   ARROWS, HARD_COPY, HPGL, LABELS, PS,
     +                   XTSHOW, YTSHOW)
C
C ACTION : X, Y titles for contours
C AUTHOR : W.G.Bardsley, University of Manchester, U.K., 26/9/95
C          28/10/1996 Changed to use PLTSTR$ 
C          20/05/2007 added INTENTS
C
      IMPLICIT   NONE 
C
C Arguments
C      
      INTEGER,             INTENT (INOUT) :: ICOLOR  
      INTEGER,             INTENT (IN)    :: ITHETA, NOUT_PS
      DOUBLE PRECISION,    INTENT (IN)    :: Y_SCALE
      CHARACTER (LEN = *), INTENT (IN)    :: ARRAYX, ARRAYY, XTITLE,
     +                                       YTITLE
      LOGICAL,             INTENT (IN)    :: ARROWS(*), HARD_COPY, HPGL,
     +                                       LABELS(*), PS, XTSHOW,
     +                                       YTSHOW
C
C Locals
C
      INTEGER    I, ISEND, L, NFONT, NGKS, NTFONT
      PARAMETER (ISEND = 1, L = 0, NGKS = 2, NTFONT = 106)
      DOUBLE PRECISION HEAD, XPT
      PARAMETER (HEAD = 0.015D+00, XPT = 1.3D+00)
      DOUBLE PRECISION X1, X2, Y1, Y2
      DOUBLE PRECISION SIZE1, SLANT, XBEGIN, YBEGIN
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO = 0.0D+00)
      CHARACTER  FONT*8, TYPE1*2
      PARAMETER (FONT = '/Courier')
C
C Externals
C
      EXTERNAL   PLTSTR$, WGB_ARROW$, WGBFNT$
C
C Draw the X Title ..................................................
C
      CALL WGBFNT$(I, NFONT,
     +             SLANT)
      IF (XTSHOW .AND. XTITLE .NE. ' ' .AND. .NOT.LABELS(1)) THEN
         IF (ITHETA.EQ.0 .OR. ITHETA.EQ.180) THEN
            XBEGIN = 0.15D+00
            YBEGIN = 0.5D+00
            TYPE1 = 'yl'
         ELSE
            XBEGIN = 0.5D+00
            YBEGIN = 0.015D+00
            TYPE1 = 'xl'
         ENDIF
         SIZE1 = XPT
         CALL PLTSTR$(ICOLOR, NTFONT, NFONT, NGKS, NOUT_PS,
     +                ZERO, SIZE1, ZERO, XBEGIN, YBEGIN, Y_SCALE,
     +                FONT, XTITLE, ARRAYX, TYPE1,
     +                HARD_COPY, HPGL, PS)
      ENDIF
C
C Draw the Y Title ..................................................
C
      IF (YTSHOW .AND. YTITLE .NE. ' ' .AND. .NOT.LABELS(2)) THEN
         IF (ITHETA.EQ.0 .OR. ITHETA.EQ.180) THEN
            XBEGIN = 0.5D+00
            YBEGIN = 0.015D+00
            TYPE1 = 'xl'
          ELSE
            XBEGIN = 0.15D+00
            YBEGIN = 0.5D+00
            TYPE1 = 'yl'
          ENDIF
         SIZE1 = XPT
         CALL PLTSTR$(ICOLOR, NTFONT, NFONT, NGKS, NOUT_PS, 
     +                ZERO, SIZE1, ZERO, XBEGIN, YBEGIN, Y_SCALE,
     +                FONT, YTITLE, ARRAYY, TYPE1,
     +                HARD_COPY, HPGL, PS)
      ENDIF
      IF (ARROWS(1) .OR. ARROWS(2)) THEN
C
C Draw the BOTTOM arrow
C
         Y1 = 0.07D+00
         Y2 = Y1
         X2 = 0.5D+00
         IF (ITHETA.EQ.0 .OR. ITHETA.EQ.90) THEN
            X1 = X2 + 0.06D+00
            X2 = X2 - 0.06D+00
         ELSE
            X1 = X2 - 0.06D+00
            X2 = X2 + 0.06D+00
         ENDIF
         IF (ITHETA.EQ.0   .AND. ARROWS(2) .AND. .NOT.LABELS(2) .OR.
     +       ITHETA.EQ.90  .AND. ARROWS(1) .AND. .NOT.LABELS(1) .OR.
     +       ITHETA.EQ.180 .AND. ARROWS(2) .AND. .NOT.LABELS(2) .OR.
     +       ITHETA.EQ.270 .AND. ARROWS(1) .AND. .NOT.LABELS(1)) THEN
            CALL WGB_ARROW$(ISEND, ICOLOR, L,
     +                      HEAD, X1, X2, Y1, Y2)
         ENDIF
C
C Draw the SIDE arrow
C
         X1 = 0.18D+00
         X2 = X1
         Y2 = 0.5D+00
         IF (ITHETA.EQ.0 .OR. ITHETA.EQ.270) THEN
            Y1 = Y2 - 0.08D+00
            Y2 = Y2 + 0.08D+00
         ELSE
            Y1 = Y2 + 0.08D+00
            Y2 = Y2 - 0.08D+00
         ENDIF
         IF (ITHETA.EQ.0   .AND. ARROWS(1) .AND. .NOT.LABELS(1) .OR.
     +       ITHETA.EQ.90  .AND. ARROWS(2) .AND. .NOT.LABELS(2) .OR.
     +       ITHETA.EQ.180 .AND. ARROWS(1) .AND. .NOT.LABELS(1) .OR.
     +       ITHETA.EQ.270 .AND. ARROWS(2) .AND. .NOT.LABELS(2)) THEN
            CALL WGB_ARROW$(ISEND, ICOLOR, L,
     +                      HEAD, X1, X2, Y1, Y2)
         ENDIF
      ENDIF
      END
C 
C