C
C
      SUBROUTINE COPYFG$(MODE,
     +                   FILE1, FILE2, TEXT, 
     +                   ABORT, CURVE, FIXCOL, FIXROW, LABEL, ORDER,
     +                   WEIGHT)
C
C ACTION : Copy, edit, etc depending on MODE ... really for graphics files
C AUTHOR : W.G.Bardsley, University of Manchester, U.K., 10/9/98
C          06/10/1998 added error indicators
C          11/10/1998 Derived from COPYFL by adding TEXT and CURVE, FIXCOL,
C                     FIXROW, LABEL, ORDER, WEIGHT to argument list to control
C                     W_EDITOR
C          14/08/1999 replaced w_editor by editor
C          28/06/2006 edited as for copyfl and copyfl$
C          20/05/2007 added INTENTS
C          19/09/2011 now calls X_COPYFG 
C
C          MODE = 1: Copy FILE1 to named file  FILE2
C          MODE = 2: Copy FILE1 to temporary   FILE2
C          MODE = 3: Copy FILE1 to named file  FILE2 ... after editing
C          MODE = 4: Copy FILE1 to temporary   FILE2 ... after editing
C          MODE = 5: Copy FILE1 to temporary   FILE2 ... after editing
C                    Then FILE1 overwritten by FILE2 ... edit/replace
C
      IMPLICIT   NONE
C
C Arguments
C      
      INTEGER,             INTENT (IN)    :: MODE
      CHARACTER (LEN = *), INTENT (IN)    :: FILE1, TEXT
      CHARACTER (LEN = *), INTENT (INOUT) :: FILE2
      LOGICAL,             INTENT (IN)    :: CURVE, FIXCOL, FIXROW,
     +                                       LABEL, ORDER, WEIGHT 
      LOGICAL,             INTENT (OUT)   :: ABORT
C
C Locals
C      
      EXTERNAL X_COPYFG 
      CALL X_COPYFG (MODE,
     +               FILE1, FILE2, TEXT, 
     +               ABORT, CURVE, FIXCOL, FIXROW, LABEL, ORDER,
     +               WEIGHT)
      END
C
C
