C
C
      SUBROUTINE EDITAX$(KANGLE, KTIC, MDROP, MTIC, NWORDS,
     +                   ZCOORD, ZDROP, ZMAX, ZMIN, ZZBOT, ZZTOP,
     +                   LOGO, WORDS, VECTOR,
     +                   DEND_G, NUMBER, PCENTX, PHIGHX, PLOTX,
     +                   ROTATE, SHOW_XAXIS, TOINT)
C
C ACTION : Edit the X-axis
C AUTHOR : W. G. Bardsley, University of Manchester, U.K., 8/11/92
C          Derived from GKSAXS by adding ROTATE etc.
C          12/09/1996 added ZCOORD, ZZBOT, ZZTOP to slide axis along
C          18/09/1996 added PLOTX
C          23/09/1996 added VECTOR
C          14/07/1997 win32 version
C          18/02/2000 added PCENTX
C          23/02/2000 added PHIGHX
C          23/10/2000 added SELSTR
C          19/12/2000 added display/suppress all labels facility
C          20/07/2001 added SHOW_XAXIS and LVIEW2
C          15/08/2001 added MDROP and ZDROP
C          13/10/2004 added ITYPE, XSIZE, STORE, WORD6, FSIZES$
C          11/07/2005 added DEND_G, call to EDITLB$ and extensive editing
C          18/10/2006 added calls to CHKTIC$ 
C          20/05/2007 added INTENTS
C          21/12/2007 added call to SAVGKS$
C          19/07/2009 added call to GRFSIG$ 
C          26/08/2009 new version of GRFSIG$ and PHIGHX now disabled but retained
C          02/12/2010 replaced SAVGKS$ by SAVLGL$
C          19/09/2011 now calls X_EDITAX
C
C          All arguments are input/output except NWORDS and LOGO (which should = 'X')
C
      IMPLICIT   NONE
C
C Arguments
C                        
      INTEGER,             INTENT (IN)    :: NWORDS
      INTEGER,             INTENT (INOUT) :: KANGLE, KTIC, MDROP, MTIC
      DOUBLE PRECISION,    INTENT (INOUT) :: ZCOORD, ZDROP, ZMAX, ZMIN,
     +                                       ZZBOT, ZZTOP
      CHARACTER (LEN = *), INTENT (INOUT) :: WORDS(NWORDS),
     +                                       VECTOR(NWORDS)
      CHARACTER (LEN = *), INTENT (IN)    :: LOGO
      LOGICAL,             INTENT (INOUT) :: DEND_G, NUMBER, PCENTX,
     +                                       PHIGHX, PLOTX(NWORDS),
     +                                       ROTATE, SHOW_XAXIS, TOINT
C
C Locals
C
      EXTERNAL X_EDITAX
      CALL X_EDITAX (KANGLE, KTIC, MDROP, MTIC, NWORDS,
     +               ZCOORD, ZDROP, ZMAX, ZMIN, ZZBOT, ZZTOP,
     +               LOGO, WORDS, VECTOR,
     +               DEND_G, NUMBER, PCENTX, PHIGHX, PLOTX,
     +               ROTATE, SHOW_XAXIS, TOINT)
      END
C
C
