c
c
      subroutine fsizes$(itype,
     +                   fsize,
     +                   store)
c
c action: store or retrieve font size correction factors
c author: w.g.bardsley, university of manchester, u.k., 13/10/2004
c         18/09/2006 added itype = 11
c         29/11/2010 added itype = 12 for extra title
c         20/01/2011 added options for further developments as follows:
c                    jtype = abs(itype) then
c                    store = .true. itype > 0: invokes a request to change font size jtype
c                                   itype < 0: store value supplied for font size jtype
c                    store = .false. just return the stored value for jtype
c         13/02/2011 added options 13, 14, and 15 and changed limits to (0.2,5.0)
c         28/05/2011 fsize is now returned if user changes the value
c         12/09/2011 now calls x_fsizes
c 
c         itype: (input/unchanged)
c                first set jtype = abs(itype) then
c         jtype: type of font required as follows:
c                jtype =  1: title (main)
c                jtype =  2: x-legend
c                jtype =  3: y-legend
c                jtype =  4: z-legend
c                jtype =  5: x-text-labels
c                jtype =  6: y-text-labels 
c                jtype =  7: z-text-labels
c                jtype =  8: bar chart labels
c                jtype =  9: pie chart labels
c                jtype = 10: panel labels
c                jtype = 11: data point labels
c                jtype = 12: title (extra)
c                jtype = 13: x_numbers
c                jtype = 14: y-numbers
c                itype = 15: z-numbers
c         fsize: (input/output) as follows:
c                store = .true. then change fsize and store a copy as follows
c                         itype > 0: interactive query
c                         itype < 0: store without a query       
c                store = .false. then just return the stored value
c         store: (input/unchanged) type of action required as above
c
      implicit   none
c
c arguments
c
      integer,          intent (in)    :: itype
      double precision, intent (inout) :: fsize
      logical,          intent (in)    :: store
c
c locals
c
      external x_fsizes 
      call x_fsizes (itype,
     +               fsize,
     +               store)
      
      end
c
c
