C
C This version of GKSAX$ is EDITAX$ with the following disabled:
C KANGLE, WORDS, VECTOR, NUMBER, ROTATE
C
      SUBROUTINE GKSAXS$(KTIC, MTIC, NWORDS,
     +                   ZCOORD, ZMAX, ZMIN, ZZBOT, ZZTOP,
     +                   LOGO,
     +                   PCENTX, PHIGHX, PLOTX, SHOW_XAXIS, TOINT)
C
C ACTION : Set up a GKS axis, KTIC = point in or out
C          NFONT = font no., MTIC = no. tick marks, SP = spacing,
C          XP = expansion factor, TOINT reals to integers
C AUTHOR : W. G. Bardsley, University of Manchester, U.K., 8/11/92
C          Derived from GKSAXS by adding ROTATE etc.
C          12/09/1996 added ZCOORD, ZZBOT, ZZTOP to slide axis along
C          18/09/1996 added PLOTX
C          23/09/1996 added VECTOR
C          14/07/1997 win32 version
C          18/02/2000 added PCENTX
C          23/02/2000 added PHIGHX
C          23/10/2000 added SELSTR
C          19/12/2000 added display/suppress all labels facility
C          20/07/2001 added SHOW_XAXIS and LVIEW2
C          18/10/2006 added call to CHKTIC$ 
C          13/04/2007 added INTENTS
C          21/07/2009 added GRFSIG$
C          26/08/2009 new version of GRFSIG$ and diabled PHIGHX but retained for future use
C          27/05/2011 improved calls to SELSTR 
C          14/09/2011 now calls X_GKSAXS
C
      IMPLICIT   NONE
C
C Arguments
C            
      INTEGER,             INTENT (IN)    :: NWORDS
      INTEGER,             INTENT (INOUT) :: KTIC, MTIC
      DOUBLE PRECISION,    INTENT (INOUT) :: ZCOORD, ZMAX, ZMIN, ZZBOT,
     +                                       ZZTOP
      CHARACTER (LEN = *), INTENT (IN)    :: LOGO 
      LOGICAL,             INTENT (INOUT) :: PCENTX, PHIGHX,
     +                                       PLOTX(NWORDS), SHOW_XAXIS,
     +                                       TOINT
C
C Locals
C      
      EXTERNAL X_GKSAXS
      CALL X_GKSAXS (KTIC, MTIC, NWORDS,
     +               ZCOORD, ZMAX, ZMIN, ZZBOT, ZZTOP,
     +               LOGO,
     +               PCENTX, PHIGHX, PLOTX, SHOW_XAXIS, TOINT)
      END
C
C
