C
C GRAF02$: CALL MENU02$ from call backs i_press_2 and i_press_3
C MENU02$: Edit titles if NPRESS = 2 or legends if NPRESS = 3
C
      SUBROUTINE GRAF02$(NPRESS)
C
C ACTION: call MENU02$ from i_press_2, i_press_3
C AUTHOR: W.G.Bardsley, University of Manchester, U.K., 29/10/2000
C         19/10/2004 minor editing
C         20/09/2011 now calls X_GRAF02
C
C         NPRESS: (input/output)
C
      IMPLICIT   NONE
C
C Argument
C
      INTEGER, INTENT (INOUT) :: NPRESS
C
C Locals
C     
      EXTERNAL X_GRAF02
      CALL X_GRAF02 (NPRESS)
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE MENU02$(ISEND, NPRESS,
     +                   DRAGTI, DRAGXL, DRAGYL, DRAGZL,
     +                   ARRAYQ, ARRAYT, ARRAYX, ARRAYY, ARRAYZ,
     +                   PTITLE, QTITLE, XTITLE, YTITLE, ZTITLE,
     +                   PIE_CHART, PLOT_TITLE, SWAP_YZ, TWO_PLOTS)

C
C ACTION : Set up titles for GKSSTY ... MENU01 in v3.2
C AUTHOR : W. G. Bardsley, University of Manchester, U.K., 28/10/93
C          19/09/1996 Added STREDI$
C          14/07/1997 win32 version
C          26/11/1997 NPRESS = 2 (TITLE), NPRESS = 3 (LEGENDS)
C          21/02/2000 added DRAGTI, DRAGXL, DRAGYL, DRAGZL
C          18/10/2000 added ARRAYQ, QTITLE
C          29/10/2000 extensive re-editing
C          07/10/2002 added savegks.ins (PIE_1, TWO_1)
C          03/12/2003 new dimensions for local arrays and (*) for arguments
C          19/10/2004 added ITYPE, TSIZE, XSIZE, YSIZE, ZSIZE, STORE1 
C          18/10/2006 rearranged the menu systems
C          19/04/2007 added INTENTS and corrected NUMOPT = 12 to NUMOPT = 11
C          01/01/2008 uses MODULE_SAVEGKS instead of savegks.ins
C          18/01/2008 now all saved variables are in MODULE_SAVEGKS
C          23/10/2010 added ROTATE_Z and adjusted menus
C          29/11/2010 added TSIZE_2 
C          20/09/2011 now calls X_MENU02
C
C          ISEND: (input/unchanged) as follows:
C                  ISEND = 1: just store
C                  ISEND = 2: edit then store
C                  ISEND = 3: retrieve
C         NPRESS: (input/unchanged) as follows:
C                  NPRESS = 2: titles
C                  NPRESS = 3: legends
C         Double precision and character arguments are (input/output)
C         but logical arguments are (input/output) 
C
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER,             INTENT (IN)    :: ISEND, NPRESS
      DOUBLE PRECISION,    INTENT (INOUT) :: DRAGTI, DRAGXL, DRAGYL,
     +                                       DRAGZL
      CHARACTER (LEN = *), INTENT (INOUT) :: ARRAYQ, ARRAYT(0:15),
     +                                       ARRAYX(0:15), ARRAYY(0:15),
     +                                       ARRAYZ(0:15), PTITLE(0:15),
     +                                       QTITLE, XTITLE(0:15),
     +                                       YTITLE(0:15), ZTITLE(0:15) 
      LOGICAL,             INTENT (INOUT) :: PIE_CHART, PLOT_TITLE, 
     +                                       SWAP_YZ, TWO_PLOTS
C
C Locals
C
      EXTERNAL X_MENU02 
      CALL X_MENU02 (ISEND, NPRESS,
     +               DRAGTI, DRAGXL, DRAGYL, DRAGZL,
     +               ARRAYQ, ARRAYT, ARRAYX, ARRAYY, ARRAYZ,
     +               PTITLE, QTITLE, XTITLE, YTITLE, ZTITLE,
     +               PIE_CHART, PLOT_TITLE, SWAP_YZ, TWO_PLOTS)
      END
C
C
