C
C GRAF04$: call MENU04$ from i_press_4
C MENU04$: Notation for axes
C
C Subroutines for SIMPLOT
C
      SUBROUTINE GRAF04$(NPRESS)
C
C ACTION: call MENU04$
C AUTHOR: W.G.Bardsley, University of Manchester, U.K., 30/10/2000
C         01/06/2001 increased NWORDS from 100 to 300
C         20/07/2001 added SHOW_XAXIS
C         15/08/2001 added MXDROP and YDROP and increased NWORDS to 1000
C         14/10/2004 added NPTS to argument list
C         14/07/2005 increased NWORDS from 1000 to 2000 and added PLOT_LABELS
C         20/09/2011 now calls X_GRAF04

C
C          NPRESS: (input/output) as follows:
C                  NPRESS .eq. 4 on entry: action then return unchanged
C                  NPRESS .ne. 4 on entry: no action the return as - NPRESS
C

      IMPLICIT   NONE
C
C Arguments
C
      INTEGER, INTENT (INOUT) :: NPRESS
C
C Locals
C
      EXTERNAL X_GRAF04
      CALL X_GRAF04 (NPRESS) 
      END
C
C----------------------------------------------------------------------
C
       SUBROUTINE MENU04$(ISEND,
     +                    KANGLE, KTIC, MXDROP, MXTIC, MYTIC, MZTIC,
     +                    NGROUP, NPTS, NWORDS,
     +                    XCOORD, XMAX, XMIN,
     +                    YCOORD, YDROP, YMAX, YMIN,
     +                    ZCOORD, ZMAX, ZMIN,
     +                    LABELS, LABVEC, WORDX, WORDY,
     +                    BAR_CHART, NUMBRX, PCENTX, PCENTY, PCENTZ,
     +                    PHIGHX, PHIGHY, PHIGHZ, PLOT_LABELS,
     +                    PLOTX, PLOTY, PLOTZ, ROTATE,
     +                    SHOW_XAXIS, SHOW_YAXIS, SHOW_ZAXIS,
     +                    TWO_PLOTS, XTOINT, YTOINT, ZTOINT)
C
C ACTION : Edit X, Y-axis notation etc. for GKSSTY ... MEN02 in v3.2
C AUTHOR : W. G. Bardsley, University of Manchester, 28/10/93
C          14/07/1997 win32 version
C          18/02/2000 added PCENTX, PCENTY, PCENTZ
C          23/02/2000 added PHIGHX, PHIGHY, PHIGHZ
C          30/10/2000 extensive re-editing
C          01/06/2001 increased NMAX from 100 to 300
C          20/07/2001 added DEND_G, SHOW_XAXIS
C          15/08/2001 added MXDROP and YDROP
C          07/10/2002 added savegks.ins (KTIC_1, LABELS_1, LABVEC_1, WORDX_1,
C                     WORDY_1, BAR_1, TWO_1, PLOTX_1, PLOTY_1, PLOTZ_1)
C          13/10/2004 added ITYPE, FSIZES$, XSIZE, and NPTS 
C          14/07/2005 added PLOT_LABELS to arguments
C          15/09/2006 revised and added BI_P and option to re-size label fonts 
C          18/10/2006 changed menu options to Exit after primary action 
C          25/12/2007 added ADJLAB$
C          01/01/2007 uses MODULE_SAVEGKS instead of savegks.ins
C          18/01/2008 transferred all saved variables to MODULE_SAVEGKS 
C          15/02/2011 added X_NUMBERS, Y_NUMBERS, Z_NUMBERS
C          27/05/2011 added call to SELSTR 
C          20/09/2011 now calls X_MENU04       
C
C          ISEND = 1: store
C          ISEND = 2: edit then store
C          ISEND = 3: retrieve
C
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER,              INTENT (IN)    :: ISEND, NWORDS
      INTEGER,              INTENT (INOUT) :: KANGLE, KTIC, MXDROP,
     +                                        MXTIC, MYTIC, MZTIC, 
     +                                        NGROUP, NPTS
      DOUBLE PRECISION,     INTENT (INOUT) :: XCOORD, XMAX, XMIN,
     +                                        YCOORD, YDROP, YMAX, YMIN,
     +                                        ZCOORD, ZMAX, ZMIN
      CHARACTER  (LEN = *), INTENT (INOUT) :: LABELS(NWORDS),
     +                                        LABVEC(NWORDS),
     +                                        WORDX(NWORDS), 
     +                                        WORDY(NWORDS)
      LOGICAL,              INTENT (INOUT) :: BAR_CHART, NUMBRX, PCENTX,
     +                                        PCENTY, PCENTZ, PHIGHX,
     +                                        PHIGHY, PHIGHZ,
     +                                        PLOT_LABELS,
     +                                        PLOTX(NWORDS),
     +                                        PLOTY(NWORDS),
     +                                        PLOTZ(NWORDS), ROTATE,
     +                                        SHOW_XAXIS, SHOW_YAXIS,
     +                                        SHOW_ZAXIS, TWO_PLOTS,
     +                                        XTOINT, YTOINT, ZTOINT
C
C Locals
C
      EXTERNAL X_MENU04
      CALL X_MENU04 (ISEND,
     +               KANGLE, KTIC, MXDROP, MXTIC, MYTIC, MZTIC,
     +               NGROUP, NPTS, NWORDS,
     +               XCOORD, XMAX, XMIN,
     +               YCOORD, YDROP, YMAX, YMIN,
     +               ZCOORD, ZMAX, ZMIN,
     +               LABELS, LABVEC, WORDX, WORDY,
     +               BAR_CHART, NUMBRX, PCENTX, PCENTY, PCENTZ,
     +               PHIGHX, PHIGHY, PHIGHZ, PLOT_LABELS,
     +               PLOTX, PLOTY, PLOTZ, ROTATE,
     +               SHOW_XAXIS, SHOW_YAXIS, SHOW_ZAXIS,
     +               TWO_PLOTS, XTOINT, YTOINT, ZTOINT)
      
      END
C
C
