C
C GRAF05$: Call MENU05$ from i_press_5
C MENU05$: Frames and sizes
C
C Subroutines for SIMPLOT
C
      SUBROUTINE GRAF05$(NPRESS)
C
C ACTION: call MENU05$ from i_press_5
C AUTHOR: W.G.Bardsley, University of Manchester, U.K., 30/10/2000
C         17/04/2001 added BORDER and GRATICULE
C         08/09/2001 added THREE_D
C         21/10/2004 added SHOW_BACKGROUND and SHOW_QUADRANTS
C         19/08/2005 added EXTEND_LINES
C         20/09/2011 now calls X_GRAF05
C
C         NPRESS: (input/output)
C
      IMPLICIT NONE
C
C Argument
C
      INTEGER, INTENT (INOUT) :: NPRESS
C
C Locals
C
      EXTERNAL X_GRAF05
      CALL X_GRAF05 (NPRESS)
      END
C
C--------------------------------------------------------------------------------
C
      SUBROUTINE MENU05$(ISEND, ISHAPE, KTIC,
     +                   THICK, XCLIP, YCLIP, ZSCALE,
     +                   BAR_CHART, BORDER, BOXIT, CENTRE, EXTEND_LINES,
     +                   FRAME, GRATICULE, OFFSET, PIE_CHART,
     +                   PLOT_TITLE, SHOW_BACKGROUND, SHOW_QUADRANTS,
     +                   THREE_D, TWO_PLOTS, XGRID, YGRID)
C
C ACTION : Edit frames and sizes for GKSSTY ... MENU03 in v3.2
C AUTHOR : W. G. Bardsley, University of Manchester, 28/10/93
C          30/07/1997 Added ISHAPE
C          03/10/1996 Redesigned to include toggling
C          04/11/1996 Added XCLIP, YCLIP
C          14/07/1997 win32 version
C          06/06/2000 improved logic and added warning about clipping
C          18/10/2000 added ISHAPE = 4, aspect ration 1:2
C          30/10/2000 extensive re-editing
C          17/04/2001 added BORDER and GRATICULE
C          08/09/2001 added THREE_D
C          07/10/2002 added SAVEGKS.INS (ISHAPE_1, KTIC_1, PIE_1, TWO_1)
C          21/10/2004 revised and added SHOW_BACKGROUND and SHOW_QUADRANTS
C          19/08/2005 added EXTEND_LINES 
C          20/04/2007 added INTENTS
C          01/01/2006 uses MODULE_SAVEGKS instead of savegks.ins 
C          10/01/2008 transferred all saved variables to MODULE_SAVEGKS  
C          04/11/2008 added calls to SAVGRD$
C          15/06/2010 added kval_11 and call to NKLCFG
C          01/12/2010 allowed horizontal grid in two plot mode
C          20/09/2011 now calls X_MENU05
C
C          ISEND: (input/unchanged) as follows:
C                 ISEND = 1: store
C                 ISEND = 2: edit then store
C                 ISEND = 3: retrieve
C          All other arguments (input/output) 
C
C
      IMPLICIT   NONE
C
C Arguments
C            
      INTEGER,          INTENT (IN)    :: ISEND
      INTEGER,          INTENT (INOUT) :: ISHAPE, KTIC
      DOUBLE PRECISION, INTENT (INOUT) :: THICK, XCLIP(2), YCLIP(2),
     +                                    ZSCALE
      LOGICAL,          INTENT (INOUT) :: BAR_CHART, PIE_CHART,
     +                                    TWO_PLOTS
      LOGICAL,          INTENT (INOUT) :: BORDER, BOXIT, CENTRE,
     +                                    EXTEND_LINES, FRAME,
     +                                    GRATICULE, OFFSET,
     +                                    PLOT_TITLE, SHOW_BACKGROUND,
     +                                    SHOW_QUADRANTS, THREE_D, 
     +                                    XGRID, YGRID
C
C Locals
C
      EXTERNAL X_MENU05 
      CALL X_MENU05 (ISEND, ISHAPE, KTIC,
     +               THICK, XCLIP, YCLIP, ZSCALE,
     +               BAR_CHART, BORDER, BOXIT, CENTRE, EXTEND_LINES,
     +               FRAME, GRATICULE, OFFSET, PIE_CHART,
     +               PLOT_TITLE, SHOW_BACKGROUND, SHOW_QUADRANTS,
     +               THREE_D, TWO_PLOTS, XGRID, YGRID)
      END
C
C
