Current C
C GRAF06$: calls MENU06$ from i_press_6
C MENU06$: Lines, symbols, error-bar types
C
C subroutines for simplot
C
      SUBROUTINE GRAF06$(NPRESS)
C
C ACTION: call MENU06$
C AUTHOR: W.G.Bardsley, University of Manchester, U.K, 30/10/2000
C         01/06/2001 increased NWORDS from 100 to 300
C         29/09/2002 increased NWORDS from 300 to 500
C         07/10/2002 set NGRAFS = 300, NWORDS = 1000
C         07/01/2003 redimensioned WIDE(5*NGRAFS)
C         25/10/2004 minor editing
C         11/07/2005 increased NWORDS from 1000 to 2000
C         10/12/2007 corrected line type 5 from <<< to >>>
C         01/01/2008 added MODULE_SAVGKS then used NXTRA
C         20/09/2011 now calls X_GRAF06
C
C         NPRESS: (input/output)
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER, INTENT (INOUT) :: NPRESS
C
C Locals
C
      EXTERNAL X_GRAF06
      CALL X_GRAF06 (NPRESS)
      END
C
C---------------------------------------------------------------------
C
      SUBROUTINE MENU06$(ISEND, IFILL, IHUE, L, LPREV, M, NFILES,
     +                   NGRAFS, NGROUP, NPTS, NSAV, NWORDS, NXTRA,
     +                   FACTOR, SIZES, WIDE,
     +                   FSAV, FSAV1, LABELS, LABVEC, TSAV,
     +                   BARCAP, BARCAP_1, BAR_CHART, PIE_CHART, LOWER,
     +                   UPPER, VECTOR_FIELD)
C
C ACTION : Edit error bars etc. for GKSSTY ... MENU04 in v3.2
C AUTHOR : W. G. Bardsley, University of Manchester, U.K, 28/10/93
C
C          20/02/1997 added BARCAP_1 and SYMBOLS to MENU05 arg list
C          14/07/1997 win32 version
C          09/03/1998 added VECTOR_FIELD
C          10/09/1998 added numeric editing, restore and save, and calls
C                     BCCOPY to update the bar chart file
C          30/10/2000 extensive re-editing
C          01/06/2001 increased KMAX from 100 to 300
C          07/10/2002 added savegks.ins (L_1, M_1, NFILES_1, NPTS_1,
C                     NSAV_1, IFILL_1, IHUE_1, WIDE_1, FSAV_1, FSAV1_1,
C                     LABELS_1, SYMBOLS_1, TSAV_1, BARCAP_2, LOWER_1,
C                     UPPER_1, BAR_1, PIE_1)
C          07/01/2003 redimensioned WIDE(5*NGRAFS)
C          09/05/2004 redimensioned NMAX to 302 and added PLOTYN$
C          25/10/2004 added call to PATCH1 and NGROUP to argument list
C          19/09/2006 added call to GKSVF7  
C          20/04/2007 added INTENTS and removed calls to SYMBOLS and SYMLAB$
C          01/02/2008 uses MODULE_SAVEGKS instead of savegks.ins 
C          30/01/2008 added call to GKSSAV$ if array size must be increased
C          01/02/2008 introduced JCOLOR_1 to menu
C          16/08/2008 added code for outline symbols (30 =< M =< 33)
C          02/01/2011 added NSTEPS
C
C          ISEND = 1: store
C          ISEND = 2: edit then store
C          ISEND = 3: retrieve
C
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER,             INTENT (IN)    :: ISEND, NGRAFS, NWORDS,
     +                                       NXTRA
      INTEGER,             INTENT (INOUT) :: IFILL(NXTRA),
     +                                       IHUE(NXTRA), NFILES,
     +                                       NGROUP, L(NGRAFS), LPREV,
     +                                       M(NGRAFS), NPTS,
     +                                       NSAV(NGRAFS)
      DOUBLE PRECISION,    INTENT (INOUT) :: FACTOR(NXTRA),
     +                                       SIZES(NGRAFS), 
     +                                       WIDE(5*NGRAFS)
      CHARACTER (LEN = *), INTENT (INOUT) :: FSAV(NGRAFS), 
     +                                       FSAV1(NGRAFS),
     +                                       LABELS(NWORDS), 
     +                                       LABVEC(NWORDS),
     +                                       TSAV(NGRAFS)
      LOGICAL,             INTENT (INOUT) :: BARCAP(NGRAFS), BARCAP_1,
     +                                       BAR_CHART, PIE_CHART,
     +                                       LOWER(NGRAFS),
     +                                       UPPER(NGRAFS), VECTOR_FIELD
C
C Locals
C
      EXTERNAL X_MENU06
      CALL X_MENU06 (ISEND, IFILL, IHUE, L, LPREV, M, NFILES,
     +               NGRAFS, NGROUP, NPTS, NSAV, NWORDS, NXTRA,
     +               FACTOR, SIZES, WIDE,
     +               FSAV, FSAV1, LABELS, LABVEC, TSAV,
     +               BARCAP, BARCAP_1, BAR_CHART, PIE_CHART, LOWER,
     +               UPPER, VECTOR_FIELD)
      
      END
C
C
