C
C GRAF07$: edit panel from call back function i_press_7
C MENU07$: edit panel from PLTPAN$ or SIMPLOT directly
C
C Subroutines for SIMPLOT
C
      SUBROUTINE GRAF07$(NPRESS)
C
C ACTION: Edit Panel from call back function i_press_7
C AUTHOR: W.G.Bardsley, University of manchester, U.K., 29/10/2000
C         01/06/2001 increased NWORDS from 100 to 300
C         28/09/2002 increased NWORDS from 300 to 500
C         07/10/2002 increased NWORDS from 500 to 1000
C         19/10/2004 minor editing
C         11/07/2005 increased NWORDS from 1000 to 2000
C         20/09/2011 now calls X_GRAF07 
C
C         NPRESS: (input/output)
C
      IMPLICIT   NONE
C
C Argument
C
      INTEGER, INTENT (INOUT) :: NPRESS
C
C Locals
C
      EXTERNAL X_GRAF07
      CALL X_GRAF07 (NPRESS)
      END
C
C--------------------------------------------------------------------
C
      SUBROUTINE MENU07$(IFILL, IHUE, ISEND, ISHAPE, KPANEL, NFILES,
     +                   NPTS, NXTRA,
     +                   FSAV1, PLINE, PSYMB,
     +                   BAR_CHART, PANEL, PIE_CHART, SIDE, TWO_PLOTS)
C
C ACTION : Edit information panel details
C AUTHOR : W. G. Bardsley, University of Manchester, U.K., 28/10/93
C          01/06/2001 increased NMAX from 100 to 300
C          07/10/2002 added savegks.ins (ISHAPE_1, IFILL_1, IHUE_1,
C                     NFILES_1, NPTS_1, FSAV1_1, BAR_1, PIE_1, TWO_1)
C          08/01/2003 added WIDE1
C          19/10/2004 added ITYPE, XSIZE, STORE, FSIZES$, CIPHER
C          20/04/2007 added INTENTS
C          01/01/2008 uses MODULE_SAVEGKS instead of savegks.ins 
C          18/01/2008 transferred all saved variables to MODULE_SAVEGKS
C          30/11/2010 allowed a side panel with double plots, introduced WIDE_PANEL,
C                     and provided font size alteration 
C          04/12/2010 added PLINE in call to PCKEYS$
C          11/02/2011 added PANEL_LINES and PANEL_SYMBOLS
C          13/05/2011 improved code for editing panel labels
C          20/09/2011 now calls X_MENU07 
C
C          ISEND: (input/unchanged) as follows:
C                  ISEND = 1: just store
C                  ISEND = 2: edit then store
C                  ISEND = 3: just retrieve
C         KPANEL: (input/unchanged) dimension
C         NWORDS: (input/unchanged) dimension
C
C         Theoretically all the other parameters can be (input/output)
C         but, if this routine is called correctly, then NFILES, NPTS,
C         FSAV1, BAR_CHART, PIE_CHART, and TWO_PLOTS should really be
C         like constant parameters to the calling programs after the
C         first call with ISEND = 1 to initialise.
C
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER,             INTENT (IN)    :: ISEND,  KPANEL, NXTRA
      INTEGER,             INTENT (INOUT) :: ISHAPE, IFILL(NXTRA),
     +                                       IHUE(NXTRA), NFILES, NPTS
      CHARACTER (LEN = *), INTENT (INOUT) :: FSAV1, PLINE(KPANEL),
     +                                       PSYMB(KPANEL)
      LOGICAL,             INTENT (INOUT) :: BAR_CHART, PANEL,
     +                                       PIE_CHART, SIDE, TWO_PLOTS
C
C Locals
C
      EXTERNAL X_MENU07
      CALL X_MENU07 (IFILL, IHUE, ISEND, ISHAPE, KPANEL, NFILES,
     +               NPTS, NXTRA,
     +               FSAV1, PLINE, PSYMB,
     +               BAR_CHART, PANEL, PIE_CHART, SIDE, TWO_PLOTS)
      END
C
C
