C
C
      SUBROUTINE RPPLOT (NOBS, NSET, NVEC,
     +                   XVEC,
     +                   TITLES)
C
C ACTION  : Supply a vector then create a range and percentiles plot
C           by calling RPPLOT$
C AUTHOR  : W. G. Bardsley, University of Manchester, U.K.
C           Derived from BWPLOT$ 17/03/2011
C
C            NOBS: (input/unchanged) observations per set(i), NOBS(i) >= 4
C            NSET: (input/unchanged) no. of sets of data
C            NVEC: (input/unchanged) total no. of items, NVEC >= sum NOBS(i)
C            XVEC: (input/unchanged) vector of values i = 1, NVEC
C          TITLES: (input/unchanged) as follows:
C                  title, x-legend, y-legend, z-legend(unused)
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER,             INTENT (IN) :: NSET, NVEC
      INTEGER,             INTENT (IN) :: NOBS(NSET)
      DOUBLE PRECISION,    INTENT (IN) :: XVEC(NVEC)
      CHARACTER (LEN = *), INTENT (IN) :: TITLES(4)  
      EXTERNAL RPPLOT$  
      CALL RPPLOT$(NOBS, NSET, NVEC,
     +             XVEC,
     +             TITLES)
      END
C
C
