C    
C SBPLOT
C Front end to SBPLOT$ 
C
      SUBROUTINE SBPLOT (ISEND, NCOL, NRMAX, NROW,
     +                   XMAT,
     +                   LABELS, TITLES)
C
C ACTION  : Supply a matrix then create a bar chart by calling GKSGRF$
C AUTHOR  : W. G. Bardsley, University of Manchester, U.K. 
C           19/05/2007 added INTENTS
C
C           ISEND: (input/unchanged) controls labels as follows:
C                  ISEND = 1: use SIMPLOT configuration labels
C                  ISEND = 2: use labels from argument list
C            NCOL: (input/unchanged) no. columns
C           NRMAX: (input/unchanged) leading dimension
C            NROW: (input/unchanged) no. rows
C            XMAT: (input/unchanged) matrix of values
C          LABELS: (input/unchanged) used aslabels if ISEND = 2
C          TITLES: (input/unchanged) as follows:
C                   title, x-legend, y-legend, z-legend(unused)
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER,             INTENT (IN) :: ISEND, NCOL, NRMAX, NROW
      DOUBLE PRECISION,    INTENT (IN) :: XMAT(NRMAX,NCOL)
      CHARACTER (LEN = *), INTENT (IN) :: LABELS(NROW), TITLES(4)
C
C Locals
C      
      EXTERNAL   SBPLOT$
      CALL SBPLOT$(ISEND, NCOL, NRMAX, NROW,
     +             XMAT,
     +             LABELS, TITLES)
      END
C
C