C
C
      SUBROUTINE SUR004$(ICOLOR, NMAX, NX, NY,
     +                   X, XT, Y, YT, Z)
C
C ACTION : Wire mesh
C AUTHOR : W.G.Bardsley, University of Manchester, U.K.24/8/95 
C          12/05/2007 added INTENTS 
C
      IMPLICIT   NONE
C
C Arguments
C      
      INTEGER,          INTENT (IN)    :: ICOLOR, NMAX, NX, NY  
      DOUBLE PRECISION, INTENT (IN)    :: X(NX), Y(NY), Z(NMAX,NY)
      DOUBLE PRECISION, INTENT (INOUT) :: XT(NX), YT(NX)
C
C Locals
C      
      INTEGER    N1
      PARAMETER (N1 = 1)
      INTEGER    I, J
      INTEGER    COLOUR_INDEX
      DOUBLE PRECISION XTEMP, YTEMP, ZTEMP
      EXTERNAL   GSELNT$, XYZ2XY$, POLYLINE$
      IF (ICOLOR.LT.0 .OR. ICOLOR.GT.71) RETURN
      COLOUR_INDEX = ICOLOR
      CALL GSELNT$(N1)
      DO I = 1, NY
         YTEMP = Y(I)
         DO J = 1, NX
            XTEMP = X(J)
            ZTEMP = Z(J,I)
            CALL XYZ2XY$(XTEMP, XT(J), YTEMP, YT(J), ZTEMP)
         ENDDO
         CALL POLYLINE$(NX, XT, YT, COLOUR_INDEX)
      ENDDO
      DO I = 1, NX
         XTEMP = X(I)
         DO J = 1, NY
            YTEMP = Y(J)
            ZTEMP = Z(I,J)
            CALL XYZ2XY$(XTEMP, XT(J), YTEMP, YT(J), ZTEMP)
         ENDDO
         CALL POLYLINE$(NY, XT, YT, COLOUR_INDEX)
      ENDDO
      END
C
C