C 
C
      SUBROUTINE SUR006$(ICOLOR, NMAX, NX, NY,
     +                   X, XT, Y, YT, Z,
     +                   WIRE)
C
C ACTION : Coloured facets
C AUTHOR : W.G.Bardsley, University of Manchester, U.K.29/8/95
C
      IMPLICIT   NONE  
C
C Arguments
C      
      INTEGER,          INTENT (IN)    :: ICOLOR, NMAX, NX, NY  
      DOUBLE PRECISION, INTENT (IN)    :: X(NX), Y(NY), Z(NMAX,NY) 
      DOUBLE PRECISION, INTENT (INOUT) :: XT(NX), YT(NY)
      LOGICAL,          INTENT (IN)    :: WIRE
C
C Locals
C      
      INTEGER    N1, N4, N5
      PARAMETER (N1 = 1, N4 = 4, N5 = 5)
      INTEGER    I, ICOUNT, ITEMP, J, JCOUNT, JTEMP, K
      INTEGER    COLOUR_INDEX
      DOUBLE PRECISION ZERO, FOUR
      PARAMETER (ZERO = 0.0D+00, FOUR = 4.0D+00)
      DOUBLE PRECISION XTEMP, YTEMP, ZMEAN, ZTEMP
      EXTERNAL   GSELNT$, XYZ2XY$, POLYLINE$, ZCOLOR$, FILL_POLYGON$
      IF (ICOLOR.LT.0 .OR. ICOLOR.GT.71) RETURN
      CALL GSELNT$(N1)
      ICOUNT = 0
      JCOUNT = 1
      DO I = 1, NX + NY - 3
         IF (I.LT.NX) THEN
            ICOUNT = ICOUNT + 1
         ELSE
            JCOUNT  = JCOUNT + 1
         ENDIF
         ITEMP = ICOUNT + 1
         JTEMP = JCOUNT - 1
         DO J = 1, I
            ITEMP = ITEMP - 1
            JTEMP = JTEMP + 1
            IF (ITEMP.LT.NX .AND. JTEMP.LT.NY) THEN
               ZMEAN = ZERO
               DO K = 1, N4
                  IF (K.EQ.1) THEN
                     XTEMP = X(ITEMP)
                     YTEMP = Y(JTEMP)
                     ZTEMP = Z(ITEMP,JTEMP)
                  ELSEIF (K.EQ.2) THEN
                     JTEMP = JTEMP + 1
                     XTEMP = X(ITEMP)
                     YTEMP = Y(JTEMP)
                     ZTEMP = Z(ITEMP,JTEMP)
                  ELSEIF (K.EQ.3) THEN
                     ITEMP = ITEMP + 1
                     XTEMP = X(ITEMP)
                     YTEMP = Y(JTEMP)
                     ZTEMP = Z(ITEMP,JTEMP)
                  ELSEIF (K.EQ.4) THEN
                     JTEMP = JTEMP - 1
                     XTEMP = X(ITEMP)
                     YTEMP = Y(JTEMP)
                     ZTEMP = Z(ITEMP,JTEMP)
                  ENDIF
                  CALL XYZ2XY$(XTEMP, XT(K), YTEMP, YT(K), ZTEMP)
                  ZMEAN = ZMEAN + ZTEMP
               ENDDO
               ITEMP = ITEMP - 1
               XT(N5) = XT(1)
               YT(N5) = YT(1)
               ZMEAN = ZMEAN/FOUR
               CALL ZCOLOR$(COLOUR_INDEX, ZMEAN)
               CALL FILL_POLYGON$(N5, XT, YT, COLOUR_INDEX)
               IF (WIRE) THEN
                  COLOUR_INDEX = ICOLOR
                  CALL POLYLINE$(N5, XT, YT, COLOUR_INDEX)
               ENDIF
            ELSE
               GOTO 20
            ENDIF
         ENDDO
   20    CONTINUE
      ENDDO
      END
C
C
