C
C
      SUBROUTINE WPSCFG$(ISEND, NMAX, IDEV_C, IVAL_C,
     +                   THICK_C, SIZE_C, XINCH_C, YINCH_C, ZSCALE_C,
     +                   NFONT_C, NCOLOR_C,
     +                   RED_C, GREEN_C, BLUE_C)
C
C ACTION : Configure w_ps.cfg
C AUTHOR : W. G. Bardsley, University of Manchester, U.K.
C          11/06/2007 now calls X_WPSCFG
C
C          ISEND = 0: Initialise everything to defaults then try to read the
C                     current values off w_ps.cfg. Finally, use the current
C                     values to overwrite the values in the argument list.
C                     This always happens first time wpscfg is called
C                     and always initialises to sensible current values.
C                     Re-set PSCOLR$
C          ISEND = 1: Copy the argument list into the current values then
C                     try to write the current values to w_ps.cfg
C                     This always happens if a failure has occurred with
C                     ISEND = 0
C                     Re-set PSCOLR$
C          ISEND = 2: Just return with arguments equal to the current values
C          ISEND = 3: Just return with arguments equal to the default values
C          ISEND = 4: Just set current values equal to arguments supplied
C          ISEND = 5: Just set current values equal to the default values
C
      IMPLICIT   NONE
C
C Arguments
C      
      INTEGER,          INTENT (IN)    :: ISEND, NMAX
      INTEGER,          INTENT (INOUT) :: IDEV_C, IVAL_C, NCOLOR_C,
     +                                    NFONT_C
      DOUBLE PRECISION, INTENT (INOUT) :: BLUE_C(NMAX), GREEN_C(NMAX),
     +                                    RED_C(NMAX)
      DOUBLE PRECISION, INTENT (INOUT) :: SIZE_C, THICK_C, XINCH_C(0:1),
     +                                    YINCH_C(0:1), ZSCALE_C(0:1)
      
C
C Call X_WPSCFG
C     
      EXTERNAL   X_WPSCFG             
      CALL X_WPSCFG (ISEND, NMAX, IDEV_C, IVAL_C,
     +               THICK_C, SIZE_C, XINCH_C, YINCH_C, ZSCALE_C,
     +               NFONT_C, NCOLOR_C,
     +               RED_C, GREEN_C, BLUE_C)
      END
C
C
