c
c The curfit package is now called dierckx.for
c e02bef$ (= curfit from the dierck spline fitting package)
c fpback
c fpbspl
c fpchec
c fpcurf
c fpdisc
c fpgivs
c fpknot
c fprati
c fprota
c
c
      subroutine e02bef$(start, m, x, y, w, s, nest, n, t, c, fp,
     +                   wrk, lwrk, iwrk, ifail)
c
c
c original arguments......
c     subroutine curfit(iopt,m,x,y,w,xb,xe,k,s,nest,n,t,c,fp,
c    * wrk,lwrk,iwrk,ier)
c
c  other subroutines required:
c    fpback,fpbspl,fpchec,fpcurf,fpdisc,fpgivs,fpknot,fprati,fprota
c
c  references:
c   dierckx p. : an algorithm for smoothing, differentiation and integ-
c                ration of experimental data using spline functions,
c                j.comp.appl.maths 1 (1975) 165-184.
c   dierckx p. : a fast algorithm for smoothing data on a rectangular
c                grid while using spline functions, siam j.numer.anal.
c                19 (1982) 1286-1304.
c   dierckx p. : an improved algorithm for curve fitting with spline
c                functions, report tw54, dept. computer science,k.u.
c                leuven, 1981.
c   dierckx p. : curve and surface fitting with splines, monographs on
c                numerical analysis, oxford university press, 1993.
c
c  author:
c    p.dierckx
c    dept. computer science, k.u. leuven
c    celestijnenlaan 200a, b-3001 heverlee, belgium.
c    e-mail : Paul.Dierckx@cs.kuleuven.ac.be
c
c***********************************************************************
c  ..
c  ..scalar arguments..
      double precision s,fp
      integer m,nest,n,lwrk,ifail
      character*1 start
c  ..array arguments..
      double precision x(m),y(m),w(m),t(nest),c(nest),wrk(lwrk)
      integer iwrk(nest)
c***********************************************************************
      external dierckx
      call dierckx(start, m, x, y, w, s, nest, n, t, c, fp,
     +             wrk, lwrk, iwrk, ifail)
      end
c
c
