C
C
      SUBROUTINE F01ADF$(N, A, IA, IFAIL)
C
C ACTION: version of F01ADF
C AUTHOR: W.G.Bardsley, University of Manchester, U.K, 24/06/2001
C         IFAIL mechanism is disabled
C
      IMPLICIT   NONE
      INTEGER    IA, IFAIL, N
      INTEGER    I, IA1, J
      DOUBLE PRECISION A(IA,*)
      DOUBLE PRECISION X
      DOUBLE PRECISION ZERO, ONE
      PARAMETER (ZERO = 0.0D+00, ONE = 1.0D+00)
      EXTERNAL   DGEMV, DTRMV, DTRSV
      INTRINSIC  SQRT
      IFAIL = 1
      DO J = 1, N
         DO I = 1, J
            A(J + 1,I) = A(I,J)
         ENDDO
      ENDDO
      DO I = 1, N
         X = A(I + 1,I)
         IF (X.LE.ZERO) RETURN
         X = SQRT(X)
         A(I + 1,I) = X
         IF (I.LT.N) THEN
            DO J = I + 2, N + 1
               A(J,I) = A(J,I)/X
            ENDDO
            CALL DGEMV('N',N-I,I,-ONE,A(I+2,1),IA,A(I+2,1),IA,ONE,A(I+2,
     *                 I+1),1)
         ENDIF
      ENDDO
      IA1 = IA
      DO I = 1, N
         X = ONE/A(I + 1,I)
         A(I + 1,I) = X
         IF (I.LT.N) THEN
            IF (I.EQ.N - 1) IA1 = 1
            DO J = I + 2, N + 1
               A(J,I) = -A(J,I)*X
            ENDDO
            CALL DTRSV('L','N','N',N-I,A(I+2,I+1),IA1,A(I+2,I),1)
         ENDIF
      ENDDO
      IA1 = IA
      DO I = 1, N
         IF (I.EQ.N) IA1 = 1
         CALL DTRMV('L','T','N',N-I+1,A(I+1,I),IA1,A(I+1,I),1)
      ENDDO
      IFAIL = 0
      END
C
C
