c
c
      subroutine clpval (isend, n,
     +                   abort)
c
c action: return values for the clipboard temporary file number
c author: w.g.bardsley, university of manchester, u.k.
c         31/01/2007 now calls x_clpval
c
c         Note: this routine must be called in sequence with isend set
c               to 1, then 2, then 3, as in the w_clpbrd subroutine
c
c         isend: (input/unchanged) as follows
c                isend = 1 ... just open w_clpbrd.cfg then return current n
c                isend = 2 ... increment n to n + 1 then update w_clpbrd.cfg
c                isend = 3 ... decrement n to n - 1 then update w_clpbrd.cfg
c             n: (output) as follows
c                abort = .true., n = - 1, isend out of range
c                abort = .true., n = - 2, w_clpbrd.cfg is read_only
c                abort = .true., n = - 3, cannot create w_clpbrd.cfg
c                abort = .true., n = - 4, cannot open w_clpbrd.cfg
c                abort = .true., n = - 5, cannot read k from w_clpbrd.cfg
c                abort = .false., 0 < n < kmax = current clipboard file number
c         abort: (output) error indicator
c
      implicit   none
c
c arguments
c
      integer, intent (in)  :: isend 
      integer, intent (out) :: n
      logical, intent (out) :: abort
c
c locals
c             
      integer  new_isend
      external x_clpval 
      new_isend = isend
      call x_clpval (new_isend, n,
     +               abort)
      end
c
c
