c
c
      subroutine get00x (icolor, ixl, iyl, kvalue, kvlim_1, kvlim_2, 
     +  l                shade, numbld, numopt, numpos, numsta,
     +                   numtxt,
     +                   xvalue,
     +                   svalue, text_in,
     +                   fixed, full, high)
c
c action : put out a text plus menu with attributes onto a window
c          This is the main simfit multi-selection box routine.
c          It can return integers, doubles, or strings 
c          It should be called via a filter such as get00n
c author : w.g.bardsley, university of manchester, u.k.
c          just calls w_get00x
c                                               
c          arguments are (input/unchanged) except for xvalue, kvalue, svalue
c          which return the edited values
c          icolor ... colour scheme (not used in this version)
c          ixl    ... x coordinate of top left hand corner
c          iyl    ... y coordinate of top left hand corner
c          kvalue ... integer values returned by this routine 
c                     also logical values 0 = .false., 1 = .true.
c                     from check box item
c          klim_1 ... lower limits for kvalue
c          klim_2 ... upper limits for kvalue
c          lshade ... shading (not used in this version)
c          numbld ... font scheme line by line
c          numopt ... number of options available
c          numpos ... type of edit box which can be of these types  
 
c                     1: integers
c                     2: double precisions
c                     3: characters
c                     4: logicals 
c                     5: limited integer using kvlim_1 and kvlim_2 
c                        returns a limited integer and kvalue must be supplied in the range set by kvlim_1 and kvlim_2 
c                     6: returns a selected value in kvalue from a ganged radio box control
c                         the ganged set must be  =< 10 and can be placed anywhere but the items
c                         must be in consecutive positions
c                     7: as for numpos(i) = 6 except that, if present, the items must be contiguous and 
c                         be positioned as a second ganged set after the main menu   
c                     8: normal text
c                     9: drop down list box

c                     The values for numpos(i) can be in any order so that a menu of numopt options
c                     can be created in any order except that the logicals, if any, are best as last  
c                     but, in any case, best visual effect is where the order is 
c                     1: integers (if any)
c                     2: doubles (if any)
c                     3: characters (if any)
c                     4: logicals (if any)
c                     5: limited integers (if any)
c                     6: ganged logicals (if any)
c                        
c          numsta ... number of line of text where menu starts (numsta > 0) 
c          numtxt ... number of lines of text (ntext >= numopt + numsta - 1)
c          xvalue ... double precision values returned by this routine
c          svalue ... character values returned by this routine
c          text   ... text array (text plus menus) so ntext >= numopt
c          fixed  ... mono spaced font (Courier New)
c          full   ... not used in this version
c          high   ... not used in this version
c
c          
c
c
c          this version creates the menu as a multi box so it does not use
c          selection by special key and some parameters are disabled, e.g.
c          icolor ... is not used in this version
c          full   ... is not used in this version
c          high   ... is not used in this version
c
c          icolor background   text     highlight-text
c          ====== ==========   ====     ==============
c          any    grey         black    blue
c
c          numbld(i)  font (Courier if fixed = .true.)
c          =========  ====
c          0, 1       Times .............. Now replaced by ms sans serif
c          2, 3       Times Italic                   "
c          4, 5       Times Bold                     "
c          6, 7       Times Bold Italic              "
c
c          text size is set by the parameters size_roman, size_courier
c          menu size is set by size_msss (if ms sans serif is used)
c
      implicit   none
c
c arguments
c      
      integer,             intent (in)    :: numopt, numtxt
      integer,             intent (in)    :: icolor, ixl, iyl, lshade,
     +                                       numsta
      integer,             intent (in)    :: numbld(numtxt),
     +                                       numpos(numopt) 
      integer,             intent (inout) :: kvalue(numopt)
      integer,             intent (in)    :: kvlim_1(numopt),
     +                                       kvlim_2(numopt)
      double precision,    intent (inout) :: xvalue(numopt) 
      character (len = *), intent (in)    :: text_in(numtxt)  
      character (len = *), intent (inout) :: svalue(numopt)
      logical,             intent (in)    :: fixed, full, high 
c
c locals
c 
      external w_get00x
      call w_get00x (icolor, ixl, iyl, kvalue, kvlim_1, kvlim_2, 
     +  l            shade, numbld, numopt, numpos, numsta, numtxt,
     +               xvalue,
     +               svalue, text_in,
     +               fixed, full, high) 
      end     
c
c