c
c
      subroutine getrow (n, 
     +                   x, 
     +                   text)
c
c action : Call datmat to get a row vector
c author : W. G. Bardsley, University of Manchester, U.K., 03/04/97
c          03/12/2006 derived from w_getrow
c
      implicit   none  
c
c arguments
c      
      integer,             intent (in)  :: n 
      double precision,    intent (out) :: x(n) 
      character (len = *), intent (in)  :: text 
c
c locals
c      
      integer    ncmax, nrmax
      parameter (ncmax = 50, nrmax = 1)
      integer    i, ncol, nrow
      double precision xtemp(nrmax,ncmax)
      logical    curve, order, vector, weight
      parameter (curve = .false., order = .false., vector = .false.,
     +           weight = .false.)
      external   datmat, putfat 
      if (n.lt.1 .or. n.gt.ncmax) then
         call putfat ('N out of range in call to GETROW')
         return
      endif   
      ncol = n
      nrow = 1
      do i = 1, ncol
         xtemp(1,i) = x(i)
      enddo
      call datmat (ncol, nrmax, nrow, 
     +             xtemp,
     +             text,
     +             curve, order, vector, weight)
      do i = 1, ncol
         x(i) = xtemp(1,i)
      enddo
      end
c
c
