c
c
      subroutine linux2 (binary, command_line)
c
c action: check for a Linux binary and, if so, alter the command line
c author: w.g.bardsley, university of manchester, u.k.
c         01/01/2007 now calls x_linux2
c
c       binary: (input/unchanged) the executable program
c command_line: (input/output) the command line, usually a file
c
c Note: calls to linux1 return the argument as follows:
c isend = 1 ... Version
c isend = 2 ... Root,         e.g Z:\    
c isend = 3 ... Home,         e.g H:\
c isend = 4 ... Linux Home,   e.g. /home/bill/
c isend = 5 ... Linux C:,     e.g. /home/bill/.wine/drive_c/
c isend = 6 ... Linux Simfit, e.g. /home/bill/.wine/drive_c/Program Files/simfit/ 
c isend = 7 ... Search path,  e.g. Z:\usr\bin\
c isend = 8 ... Search path,  e.g. Z:\usr\local\bin\
c isend = 9 ... Search path,  e.g. Z:\opt\kde4\bin\  
c isend = 10 ... Search path, e.g. Z:\opt\gnome\bin\  
c isend = 11 ... editor
c isend = 12 ... explorer               
c isend = 13 ... PS-driver  
c isend = 14 ... clipboard viewer  
c isend = 15 ... PS-viewer  
c isend = 16 ... PDF-reader  
c isend = 17 ... calculator  
c                                            
c
      implicit none
c
c arguments
c
      character (len = *), intent (in)    :: binary  
      character (len = *), intent (inout) :: command_line      
c
c locals
c      
              
      character  new_binary*1024
      external   x_linux2
      new_binary = binary
      call x_linux2 (new_binary, command_line) 
      end
c
c      
               