C
C Function NITEMS removed from MAKSIM to be available for general use
C
      INTEGER FUNCTION MAKSIM_NITEMS(STRNG)
C
C            Number of items in a string where tabs, spaces, commas, or semicolons break 
C            up into tokens. It assumes a previous call to MAKSIM_COMMAS has occurred.
C 28/07/2008 removed from MAKSIM and developed for more general use
C
      IMPLICIT   NONE
C
C Argument
C      
      CHARACTER (LEN = *), INTENT (IN) :: STRNG
C
C Locals
C      
      INTEGER    I, LEN200, N
      CHARACTER  BLANK*1, COMMA*1, SEMI*1, TAB*1
      PARAMETER (BLANK = ' ', COMMA = ',', SEMI = ';')
      CHARACTER  BEFORE*1, NOW*1
      EXTERNAL   LEN200
      INTRINSIC  CHAR
      MAKSIM_NITEMS = 0
      N = LEN200(STRNG)
      
      TAB = CHAR(9)
      IF (N.LE.0         .OR. 
     +    STRNG.EQ.BLANK .OR.
     +    STRNG.EQ.COMMA .OR.
     +    STRNG.EQ.TAB   .OR.
     +    STRNG.EQ.SEMI) RETURN
     
      BEFORE = BLANK
      DO I = 1, N
         NOW = STRNG(I:I)
         IF (BEFORE.EQ.BLANK .OR.
     +       BEFORE.EQ.COMMA .OR.
     +       BEFORE.EQ.TAB   .OR.
     +       BEFORE.EQ.SEMI) THEN
     
             IF (NOW.NE.BLANK .AND.
     +           NOW.NE.COMMA .AND.
     +           NOW.NE.TAB   .AND.
     +           NOW.NE.SEMI) MAKSIM_NITEMS = MAKSIM_NITEMS + 1
     
         ENDIF
         BEFORE = NOW
      ENDDO
      END
C
C