C
C
      SUBROUTINE DLLMAT (X, Y,
     +                   D)
C
C ACTION : Return the version number, signature and details for DLLs
C AUTHOR : W.G.Bardsley, University of Manchester, UK, 5/8/98
C          24/05/2007 added INTENTS
C          14/08/2007 added call to A00ACF
C          17/07/2011 set XFIXED = YFIXED = 0 to stop checking by DLLCHK
C
C          XFIXED = SIMFIT version number
C          YFIXED = SIMFIT release number
C          DFIXED = SIMFIT description
C
      IMPLICIT   NONE
C
C Arguments
C
      DOUBLE PRECISION,    INTENT (OUT) :: X, Y
      CHARACTER (LEN = *), INTENT (OUT) :: D
C
C Parameters that must be updated at each revision
C
      DOUBLE PRECISION XFIXED, YFIXED
      CHARACTER  DFIXED*30, FIXEDD*30
      PARAMETER (XFIXED = 0.0D+00,
     +           YFIXED = 0.0D+00)    
      PARAMETER (DFIXED = 'NAG FLDLL214Z_NAG Licence OK',
     +           FIXEDD = 'NAG FLDLL214Z_NAG NO LICENCE') 
C
C Logical function
C
      LOGICAL A00ACF
      EXTERNAL A00ACF
C
C Now define the variables
C
      X = XFIXED
      Y = YFIXED
      IF (A00ACF()) THEN
         D = DFIXED
      ELSE
         D = FIXEDD
      ENDIF
      END
C
C
