@echo off

echo.
echo.
echo ****************************************************************
echo *  A batch file to make the two DLL files                      *
echo *  fldll224m_nag_maths.dll                                     *
echo *  fldll224m_mkl_maths.dll                                     *
echo *  which allow simfit to use the NAG library at Mark 22        *
echo *  Full details are in the document nag_simfit.pdf.            *
echo *  Edit this batch file for any other release of the NAG DLLs. * 
echo *  Requirement: Silverfrost FTN95.EXE must be on the path and  *        
echo *               all paths in the link script must be correct.  *
echo ****************************************************************

echo.
echo -------
echo Step 1: Compile all the *.f source code (optional if all *.obj files exist)
echo -------
echo.

pause

ftn95 /f_stdcall getifa_ftn95.f95
ftn95 /f_stdcall *.f

echo.
echo -------
echo Step 2: Create the new nag dll linked to the mark22m NAG DLL
echo -------
echo.

pause

slink nag_mark22m.link

echo.
echo -------
echo Step 3: Create the new mkl dll linked to the mark22m mkl NAG DLL
echo -------
echo.

pause

slink mkl_mark22m.link

echo.
echo ------- 
echo Step 4: Don't forget to edit change_simfit_version.config
echo ------- then overwrite the version in the simfit\bin folder.
echo         Also add this new DLL to the simfit\bin folder.
echo         Then, as administrator, run change_simfit_version.exe
echo         in the simfit\bin folder.  
echo.
echo.
