@echo off

echo.
echo.
echo ****************************************************************
echo *  A batch file to make the two DLL files                      *
echo *  fldll234m_nag_maths.dll                                     *
echo *  fldll234m_mkl_maths.dll                                     *
echo *  which allow simfit to use the NAG library at Mark23         *
echo *  Full details are in the document nag_simfit.pdf.            *
echo *  Edit this batch file for any other release of the NAG DLLs. * 
echo *  Requirement: The NAGfor compiler must be on the path and    *        
echo *               all paths in the link scripts must be correct. *
echo ****************************************************************


echo.
echo -------
echo Step 1: Compile all the *.f source code (optional if all *.obj files exist)
echo -------
echo.

pause

nagfor -f77 -c getifa_nagfor.f95
nagfor -f77 -c *.f

echo.
echo -------
echo Step 2: Create the new nag dll linked to the nag mark23m NAG DLL
echo -------
echo.

pause

nagfor @nag_mark23m_nagfor.link

echo.
echo -------
echo Step 3: Create the new mkl dll linked to the mkl mark23m NAG DLL
echo -------
echo.

pause

nagfor @mkl_mark23m_nagfor.link

echo.
echo ------- 
echo Step 4: Don't forget to edit change_simfit_version.config
echo ------- then overwrite the version in the simfit\bin folder.
echo         Also add these new DLLs to the simfit\bin folder.
echo         Then, as administrator, run change_simfit_version.exe
echo         in the simfit\bin folder.  
echo.
echo.
