@echo off

echo.
echo.
echo ****************************************************************
echo *  A batch file to make the two DLL files                      *
echo *  fldll26de_nag_maths.dll                                     *
echo *  fldll26de_mkl_maths.dll                                     *
echo *  which allow simfit to use the NAG library at Mark26         *
echo *  Full details are in the document nag_simfit.pdf.            *
echo *  Edit this batch file for any other release of the NAG DLLs. * 
echo *  Requirement: Silverfrost FTN95.EXE must be on the path and  *        
echo *               all paths in the link scripts must be correct. *
echo ****************************************************************


echo.
echo -------
echo Step 1: Compile all the *.f source code (optional if all *.obj files exist)
echo -------
echo.

pause

ftn95 /f_stdcall getifa_ftn95.f95
ftn95 /f_stdcall *.f

echo.
echo -------
echo Step 2: Create the new nag dll linked to the nag mark26de NAG DLL
echo -------
echo.

pause

slink nag_mark26de.link

echo.
echo -------
echo Step 3: Create the new mkl dll linked to the mkl mark26de NAG DLL
echo -------
echo.

pause

slink mkl_mark26de.link

echo.
echo ------- 
echo Step 4: Don't forget to edit change_simfit_version.config
echo ------- then overwrite the version in the simfit\bin folder.
echo         Also add these new DLLs to the simfit\bin folder.
echo         Then, as administrator, run change_simfit_version.exe
echo         in the simfit\bin folder.  
echo.
echo.
