c
c
      subroutine m_kencon (ncmax, ncol, nout, nrmax, nrow,
     +                     a,
     +                     fname, title,
     +                     newdat)
c
c action: front end to kencon
c author: w.g.bardsley, university of manchester, u.k., 20/08/2007
c
      implicit none
c
c arguments
c          
      integer,             intent (in)  :: ncmax, ncol, nout,
     +                                     nrmax, nrow
      double precision,    intent (in)  :: a(nrmax,ncmax)
      character (len = *), intent (in)  :: fname, title
      logical,             intent (out) :: newdat   
c
c local allocatable workspace
c      
      double precision, allocatable :: b(:), c(:,:), x(:)
c
c locals
c      
      integer    ierr, ncmax1, nrmax1
      integer    nin, nsmall
      parameter (nin = 3, nsmall = 1)
      character  fsav(nsmall)*1, tsav(nsmall)*1
      logical    supply
      parameter (supply = .true.)
      external   kencon
      newdat = .false.
      ierr = 0
      if (allocated(b)) deallocate(b, stat = ierr)
      if (ierr.ne.0) return  
      if (allocated(c)) deallocate(c, stat = ierr)
      if (ierr.ne.0) return
      if (allocated(x)) deallocate(x, stat = ierr)
      if (ierr.ne.0) return  
      ncmax1 = ncmax
      nrmax1 = nrmax     
      allocate(b(nrmax1), stat = ierr)
      if (ierr.ne.0) return 
      allocate(c(nrmax1,ncmax1), stat = ierr)
      if (ierr.ne.0) return
      allocate(x(nrmax1), stat = ierr)
      if (ierr.ne.0) return
      call kencon (ncmax, ncol, nout, nin, nrmax, nrow, nsmall,
     +             a, b, c, x,
     +             fname, fsav, title, tsav,
     +             newdat, supply)
      deallocate(b, stat = ierr)
      deallocate(c, stat = ierr)
      deallocate(x, stat = ierr)
      end
c
c         