c
c
      subroutine m_randat
c
c action: temporary front end to randat
c author: w.g.bardsley, university of manchester, u.k., 28/02/2006
c
      implicit   none
c
c local allocatable workspaces
c
      integer, allocatable :: iseq(:), ivec(:)
      double precision, allocatable :: uvec(:), xvec(:)
c
c locals
c
      integer    ierr
      integer    nivec, nxvec
      parameter (nivec = 5000, nxvec = nivec)
      external   randat
      ierr = 0
      if (allocated(iseq)) deallocate(iseq, stat = ierr)
      if (ierr.ne.0) return
      if (allocated(ivec)) deallocate(ivec, stat = ierr)
      if (ierr.ne.0) return
      if (allocated(uvec)) deallocate(uvec, stat = ierr)
      if (ierr.ne.0) return
      if (allocated(xvec)) deallocate(xvec, stat = ierr)
      if (ierr.ne.0) return
      allocate(iseq(nivec), stat = ierr)
      if (ierr.ne.0) return
      allocate(ivec(nivec), stat = ierr)
      if (ierr.ne.0) return
      allocate(uvec(nxvec), stat = ierr)
      if (ierr.ne.0) return
      allocate(xvec(nxvec), stat = ierr)
      if (ierr.ne.0) return
      call randat (iseq, ivec, nivec, nxvec,
     +             uvec, xvec)
      deallocate(iseq, stat = ierr)
      deallocate(ivec, stat = ierr)
      deallocate(uvec, stat = ierr)
      deallocate(xvec, stat = ierr)
      end
c
c
