C
C
      SUBROUTINE POLADV (NTYPE)
C
C Help
C
      IMPLICIT   NONE
C
C Argument (from POL006)
C      
      INTEGER, INTENT (IN) :: NTYPE
C
C Locals
C          
      INTEGER    NUMTXT
      INTEGER    NUMBLD(30)
      CHARACTER (LEN = 100) TEXT(30)
      EXTERNAL   PATCH2
      DATA       NUMBLD / 30*0 /
      IF (NTYPE.LT.3) THEN
         NUMTXT = 21
         WRITE (TEXT,100)
      ELSE
         NUMTXT = 23   
         WRITE (TEXT,200)
      ENDIF   
      NUMBLD(1) = 1
      CALL PATCH2 (NUMBLD, NUMTXT,
     +             TEXT)
  100 FORMAT (
     + 'Fitting straight lines by weighted least squares'
     +/
     +/'This procedure fits a polynomial of degree 1 of the form'
     +/'f(x) = p(0) + p(1)x'
     +/'to x, y, s data, where x are in nondecreasing order, y are'
     +/'measured responses, and s are weights = std.dev.y (or s = 1).'
     +/
     +/'Options available are as follows.'
     +/
     +/'1.`Best-fit parameters can be inspected.'
     +/'2.`95% confidence limits can added to the best-fit plot.'
     +/'3.`The best-fit straight line can be used as a standard curve'
     +/'  `to predict x with 95% confidence limits given y.'
     +/'4.`Such values of y for calibration purposes can be input'
     +/'  `in one of three ways.'
     +/'  `a) Input from the terminal but not saved'
     +/'  `b) Input from the terminal then saved to a temporary file'
     +/'  `c) Input from a data file containing a column of numbers'
     +/'5.`In addition the advanced mode provides further options such'
     +/'  `as calculating comprehensive linear regression and goodness'
     +/'  `of fit statistics with analysis of residuals.')     
  200 FORMAT (
     + 'Fitting polynomials by weighted least squares'
     +/
     +/'This procedure fits a degree n polynomial of the form'
     +/'f(x) = p(0) + p(1)x + p(2)x^2 + ... + p(n)x^n'
     +/'to x, y, s data, where x are in nondecreasing order, y are'
     +/'measured responses, and s are weights = std.dev.y (or s = 1).'
     +/
     +/'Some options that may be provided are as follows.'
     +/
     +/'1.`Statistics may be given to choose the degree n.'
     +/'2.`A line (n = 1), quadratic (n = 2), or cubic (n = 3)'
     +/'  `will usually be sufficient for calbration.'
     +/'3.`A plot of the best fit polynomial can be plotted, with'
     +/'  `95% confidence limits if required'
     +/'4.`Given estimates of y as single observations, predicted'
     +/'  `values of x can be estimated with confidence limits.'
     +/'5.`Given values for x, the corresponding values of f(x)'
     +/'  `can be evaluated with 95% confidence limits.'
     +/'6.`Such values of x or y for prediction or evaluation can'
     +/'  `be input in one of three ways.'
     +/'  `a) Input from the terminal but not saved'
     +/'  `b) Input from the terminal then saved to a temporary file'
     +/'  `c) Input from a data file containing a column of numbers')
      end
C
C
