%
% ****************************************************************
% This is the header file defining the simfit dictionary that
% you can cut out of simfit ps files to send as a separate header
% file using dvips if you need to save space and speed up printing
% This file is used by psfragex.tex
% ****************************************************************
%
%prolog(1) to (6) can be used by DVIPS as a header
%****cut the invariant prolog/header out from here
/SIMFIT 200 dict def SIMFIT begin
%
% prolog(1): definitions
%
/C{copy}def /D{def}def /E{exch}D /F{findfont}D /GR{grestore}D
/GS{gsave}D /M{moveto}D /N{newpath}D /P{pop}D /R{rmoveto}D
/S{scalefont setfont}D /d{dup}D /i{putinterval}D /p{put}D
%
% prolog(2): construct Greek/maths font
%
/Symbol F d length dict begin
{1 index /FID ne {D} {P P} ifelse} forall Encoding d length array C
d 33 [/perpendicular /Rfraktur /infinity /infinity /aleph /circleplus
/spade /heart /club /multiply /plusminus /lozenge /approxequal /bullet
/divide /radical /florin /partialdiff /gradient /integral /product
/summation /arrowright /arrowleft /arrowup /arrowdown /arrowboth
/lessequal /equivalence /greaterequal /notequal /degree] i
d 67 /Gamma p d 99 /gamma p
d 70 [/Zeta /Eta /Theta] i d 102 [/zeta /eta /theta1] i
d 74 [/Kappa /Lambda /Mu /Nu /Xi] i d 106 [/kappa /lambda /mu /nu /xi] i
d 81 [/Rho /Sigma /Tau /Upsilon1 /Phi /Chi /Psi /Omega /partialdiff
      /element] i
d 113 [/rho /sigma /tau /upsilon  /phi1 /chi /psi /omega /theta /phi] i
       /Encoding E D currentdict end /Greek E definefont P
%End definition of Greek font
%
%prolog (3): character functions
%
/bs{false charpath GS 5.0 setlinewidth stroke GR currentpoint
    fill N M}D /a1 (A) D
/PSfrag where
   {P /fx{/ar E D /st E D PSfragLib /S get st /convert PSfrag
    known {st show} {f1} ifelse GR}D}
   {/fx{/ar E D /st E D f1 GR}D} ifelse
/f1{0 1 st length 1 sub {d st E get a1 E 0 E p a1 E f2} for}D
/f2{ar E get /nu E D     % ... get the text key
    nu 48 gt nu 58 lt and% ... is it in 0 to 9?
   {nu 49 eq {sb} if nu 50 eq {sp} if
    nu 51 eq {g1 show g2} if nu 52 eq {g1 sb g2} if nu 53 eq
   {g1 sp g2} if nu 54 eq {g1 bs g2} if nu 55 eq {g3 show g2} if
    nu 56 eq {g4 show g2} if
    nu 57 eq {special} if}
   {nu 64 gt nu 75 lt and% ... is it in A to I?
   {nu 65 eq {g5 show g6 h1} if nu 66 eq {g5 show g6 h2} if
    nu 67 eq {g5 show g6 h3} if nu 68 eq {g5 show g6 h4} if
    nu 69 eq {g5 show g6 h5} if nu 70 eq {g5 show g6 h6} if
    nu 71 eq {g5 g1 show g2 g6 h3} if
    nu 72 eq {g5 g1 show g2 g6 h5} if
    nu 73 eq {g5 g1 bs g2 g6 h3} if
    nu 74 eq {g5 g1 bs g2 g6 h5} if}
   {show} ifelse}        % ... if key not valid
    ifelse}D
/f3{F size S}D /f4{S 3 -1 roll d stringwidth P}D /f5{S M}D
/f6{4 -1 roll E sub 3 -1 roll M GS}D /f7{3 -1 roll E M GS}D
/g1{d ($) eq {P (\243)} {/Greek f3} ifelse}D
/g2{font f3}D /g3{/ZapfDingbats f3}D
/g4{/ISOLatin1Encoding where {P font F d length dict begin
    {1 index /FID ne {D} {P P} ifelse}forall
    /Encoding ISOLatin1Encoding D currentdict end
    /ISO E definefont P /ISO f3}if}D
/g5{d GS newpath 0 0 M true charpath pathbbox GR /h E D /w E D P P}D
/g6{GS 0 0 M (a) true charpath pathbbox GR /ha E D P P P GS w neg}D
/h1{h ha sub R w (\301) stringwidth P sub .5 mul 0 R (\301) show GR}D
/h2{h ha sub R w (\302) stringwidth P sub .5 mul 0 R (\302) show GR}D
/h3{h ha sub R w (\303) stringwidth P sub .5 mul 0 R (\303) show GR}D
/h4{h ha sub R w (\304) stringwidth P sub .5 mul 0 R (\304) show GR}D
/h5{h ha sub R w (\305) stringwidth P sub .5 mul 0 R (\305) show GR}D
/h6{h ha sub R w (\310) stringwidth P sub .5 mul 0 R (\310) show GR}D
/ti{/font ti-font D /size ti-size D ti-font F ti-size f4 2 div f6}D
/xl{/font xl-font D /size xl-size D xl-font F xl-size f4 2 div f6}D
/yl{/font yl-font D /size yl-size D yl-font F yl-size f4 2 div
    3 -1 roll E sub f7 90 rotate}D
/zl{/font zl-font D /size zl-size D zl-font F zl-size f4 2 div
    3 -1 roll E add f7 -90 rotate}D
/tc{/font tc-font D /size tc-size D tc-font F tc-size f4 2 div f6}D
/td{/font td-font D /size td-size D td-font F td-size f4 3 -1 roll
    E sub f7 90 rotate 0 td-size 3 div neg R}D
/tl{/font tl-font D /size tl-size D tl-font F tl-size f5 GS}D
/ty{/font ty-font D /size ty-size D ty-font F ty-size f5 d stringwidth
    P neg ty-size 3 div neg R GS}D
/tz{/font tz-font D /size tz-size D tz-font F tz-size f5 0 tz-size
    3 div neg R GS}D
/tr{/font tr-font D /size tr-size D tr-font F tr-size f4 f6}D
/sb{0 size y-down mul R GS sb-size sb-size scale d stringwidth P E
    show GR sb-size mul size y-down mul -1 mul R}D
/sp{0 size y-up mul R GS sp-size sp-size scale d stringwidth P E
    show GR sp-size mul size y-up mul -1 mul R}D
%
%prolog (4): lines
%
/l1{0 setdash N 3 1 roll}D /l2{M 1 sub {lineto} repeat stroke GR}D
/da{GS [60 40] l1 l2}D /do{GS [20 40] l1 l2}D
/dd{GS [60 40 20 40] l1 l2}D /li{M lineto stroke}D
/pl{GS N 3 1 roll l2}D
%
%prolog (5): polygons
%
/p1{N 3 1 roll M 1 sub {lineto} repeat closepath}D
/pc{p1 stroke}D /pe{GS p1 background fill GR}D /pf{p1 fill}D
%
%prolog (6): symbols
%
/s1{N x y z}D /s2{arc closepath GS}D /xyz{/z E D /y E D /x E D}D
/xa{x z add}D /xs{x z sub}D /ya{y z add}D /ys{y z sub}D
/ad{xyz x ys x ya li xs y xa y li}D /as{3 C ad cr}D
/ce{xyz s1 0 360 s2 1 setgray fill GR stroke}D
/ch{xyz s1 90 270 s2 1 setgray fill GR s1 90 270 arcn closepath fill s1
    0 360 arc closepath stroke}D
/cf{xyz s1 0 360 s2 fill GR stroke}D
/cr{xyz z 2.0 sqrt div /z E D xs ys xa ya li xa ys xs ya li}D
/de{xyz x ys xa y x ya xs y 4 9 C pe pc}D
/dh{xyz x ys xa y x ya 3 pf x ys x ya xs y 3 pe x ys xa y x ya xs y 4
    pc}D /mi{xyz xs y xa y li}D
/df{xyz x ys xa y x ya xs y 4 9 C pf pc}D
/se{xyz xa ys xa ya xs ya xs ys 4 9 C pe pc}D
/sh{xyz x ys xa ys xa ya x ya 4 pf x ys x ya xs ya xs ys 4 pe xa ys xa
    ya xs ya xs ys 4 pc}D
/sf{xyz xa ys xa ya xs ya xs ys 4 9 C pf pc}D
/te{xyz xa ys x ya xs ys 3 7 C pe pc}D
/th{xyz x ys xa ys x ya 3 pf x ys x ya xs ys 3 pe xa ys x ya xs ys 3
    pc}D /tf{xyz xa ys x ya xs ys 3 7 C pf pc}D
end
%****cut the invariant prolog/header down to here
%
