 
  SIMFIT information bulletin w_readme.I3 (= readme.1st): Version 6
  =======================================================

  Advice for first time users

  The programs and test files
  ===========================
  The Simfit package contains some forty programs covering many aspects
  of simulation, fitting, statistics and plotting.

  To get started, you should choose the program required and run it
  with the demonstration example files provided. To find an appropriate
  test file from the file [Open] control, press [Help] to read about 
  the test file options, press [View] to browse the files available,
  then press [Demo] and select a suitable test file.
    
  Only when you have seen how Simfit works with correctly formatted 
  data in the test files should you try to analyse your own data.

  Clearly, if Simfit works with a test file but fails with your data,
  then your data file is not formatted correctly.
    
  Note that, if the Simfit menus or graphs are too small to read, or 
  they are so large that they overflow, you can press [Configure],
  adjust the font or graphics display sizes, then press [Apply].
    
  Information
  ===========
  Sources of information are the individual tutorials provided with
  each program, the help program, the w_readme files (the index is 
  w_readme.0 = w_readme.index), the test files, or the manual in
  pdf format. A summary of Simfit (simfit_summary.pdf) with collages 
  to illustrate graphical procedures is also provided.
    
  If Simfit is set up correctly you can view all of these
  directly from the program controller, w_simfit.exe in
  32-bit versions or x64_simfit.exe in 64-bit versions.
    
  Exit strategy
  =============  
  You can stop and quit from any executing Simfit program using 
  Program Manager or the upper right hand closure cross but, if
  you do this, some results for the current analysis done by that 
  program may be lost and not written to the vorresponding results
  log file.

  The Simfit program manager can be minimised, maximised, or closed
  in the usual way from the system menu at top left or right, but
  the minimisation and system menu icons are mostly disabled while 
  the individual sub-programs are executing to avoid interference
  between other Simfit programs that may be acticve at the same time 
    
  Scientific notation
  ===================
  Simfit sometimes uses scientific notation, where E+ab means ten to 
  the power ab, and commas act as separators.

  For instance, 1.234E+02 = 123.4 and 1.234E-02 = 0.01234, while
  1,2 means the number pair 1 and 2.

  From Version 8 the output format and number of significant figures
  can be altered from the Advanced Editing option avilable from the
  [Configure] control. 
    
  Using the clipboard
  =================== 
  To analyse clipboard data, just copy the table of values to the
  clipboard from your spreadsheet. Then, from the Simfit menu,
  select the program required and click on the file selection
  [Paste] button when a data file is requested. If the data are
  correctly formatted, Simfit will create a temporary file containing
  the clipboard data, which you can save eventually if required.
    
  For instance, select column 1 = x and column 2 = y from your
  spreadsheet, copy to the clipboard, then plot the clipboard data
  using program Simplot.
    
  Interface to Excel
  ==================
  Users of MS Excel
  will find it convenient to load one of the Simfit Excel macros
  (e.g. simfit6.xls) to create Simfit files directly from Excel.
  To do this, the macro must be loaded before you select data
  columns from your database to write out to file. The macros
  can be found in the Simfit installation doc folder. 

  Auxiliaries
  ===========
  Configure Simfit to use your own text-editor or word-processor 
  for editing but you do not need to install Gsview or Ghostscript 
  to view .ps and .eps files, transform .eps to bit maps and other
  graphics files.
      
  Advanced procedures
  ===================
  Everything in Simfit is available at two levels. So, if you are
  not satisfied with a statistical analysis, curve fit or graph at
  the elementary level, you must turn to the more advanced level,
  which offers greater power, but demands more sophistication from 
  users.
    
  For instance, after doing enzyme kinetics with substrate (program
  MMFIT) and inhibitor (program RFFIT) separately,  you could fit
    
  v = f(S,I)
    
  as a surface (i.e. a function of two variables using program QNFIT).
    
  Warning: fitting surfaces, differential equations or your own models
  requires patience and expertise.
  
  Hardcopy
  ========
  You can copy to the clipboard, drive printers, or save files directly
  from graphical displays but, for publication quality graphs with
  overlays, Greek, maths symbols, accents, rotated fonts, variable
  line thickness, etc., create ASCII coordinate files, assemble into 
  library files or add to your project archive, read them into program
  SIMPLOT and create Encapsulated PostScript files (.eps).

  Alternatively, data can be transferred interactively into program
  SIMPLOT from any Simfit graph, by choosing the [Advanced] option
  The recommended way use Simfit graphics is to always create compact 
  industry standard PostScript files, and have nothing to do with bulky
  low resolution bitmaps (.bmp), compressed bitmaps (.pcx, .tif, .jpg)
  or enhanced meta files (.emf).
    
  Simfit PostScript files can be edited, printed, re-sized, collected 
  into collages, transformed into other formats or viewed (using program
  EDITPS), or included in documents. If you do not have a PostScript
  printer, print or transform the PostScript files from Simfit using
  the option prodvided to transform internally ito *.pdf files and 
  pass them on to your default PDF voewer. Otherwise just transform
  the Postscript files into portable network graphics files (*.png)
  which can now be handled by the Web and all Windows programs.


