c
c
      program help
c
c action : html version of the SIMFIT help program
c author : w.g.bardsley, university of manchester, u.k., 16/12/98
c          04/07/1999 added excel
c          18/09/1999 added test files
c          15/11/1999 added call to dllchk so that help can check the
c                     local dlls but also to support calls from run5
c          12/02/2000 added call to simver
c          10/04/2000 increased no. sig. figures in xver and yver
c                     and deleted obsolete code for testing if called
c                     from run5
c          28/02/2002 finalised on no_minbox,topmost for %ww
c          31/01/2003 added results
c          16/02/2004 new version calling w_help.dll
c          03/04/2005 now calls palett$ if link(1:6) = 'palett'
c          19/07/2005 deleted call to simver and dllchk and edited help.lnk
c                     to link to w_help.dll, w_menus.dll, and w_graphics.dll
c          01/10/2005 deleted call to palett$
c
c          usage: help link
c          ================
c          The command line is taken as the name of the link required
c          for the hypertext start unless it is not one of the accepted
c          links when menu is assumed.
c
c
      implicit   none   
      integer    number, length, status
      character  link*100
      character  blank*1
      parameter (blank = ' ')
      external   lcase1
      external   help_main
      external  
     +help_adderr,   help_average, 
     +help_binomial, 
     +help_calcurve, help_chisqd,  help_compare, help_csafit,
     +help_deqsol, 
     +help_editfl,   help_editmt,  help_editps,  help_eoqsol, 
     +help_exfit,
     +help_ftest,
     +help_gcfit,
     +help_hlfit,
     +help_inrate,
     +help_linfit,
     +help_makcsa,   help_makdat,  help_makfil,   help_maklib, 
     +help_makmat,   help_maksim,  help_mmfit,
     +help_normal,      
     +help_polnom,      
     +help_qnfit,      
     +help_rannum,   help_rffit,   help_rstest,      
     +help_sffit,    help_simplot, help_simstat, help_spline,
     +help_ttest,
     +help_usermod      
      intrinsic command_argument_count, get_command_argument
c
c Get the command line
c                                     
      number = command_argument_count()
      if (number.eq.1) then
         call get_command_argument (number, link, length, status)
         if (status.eq.0) then 
            call lcase1 (link)
         else   
            link = blank 
         endif   
      else
         link = blank
      endif      
      if (link.eq.'adderr') then
         call help_adderr (link)
      elseif (link.eq.'average') then
         call help_average (link)   
      elseif (link.eq.'binomial') then
         call help_binomial (link)
      elseif (link.eq.'calcurve') then
         call help_calcurve (link)
      elseif (link.eq.'chisqd') then
         call help_chisqd (link)
      elseif (link.eq.'compare') then
         call help_compare (link)
      elseif (link.eq.'csafit') then
         call help_csafit (link)
      elseif (link.eq.'deqsol') then
         call help_deqsol (link)   
      elseif (link.eq.'editfl') then
         call help_editfl (link)
      elseif (link.eq.'editmt') then
         call help_editmt (link)
      elseif (link.eq.'editps') then
         call help_editps (link)
      elseif (link.eq.'eoqsol') then
         call help_eoqsol (link)
      elseif (link.eq.'exfit') then
         call help_exfit (link)  
      elseif (link.eq.'ftest') then
         call help_ftest (link)
      elseif (link.eq.'gcfit') then
         call help_gcfit (link) 
      elseif (link.eq.'hlfit') then
         call help_hlfit (link)
      elseif (link.eq.'inrate') then
         call help_inrate (link)
      elseif (link.eq.'linfit') then
         call help_linfit (link)   
      elseif (link.eq.'makcsa') then
         call help_makcsa (link)
      elseif (link.eq.'makdat') then
         call help_makdat (link)
      elseif (link.eq.'makfil') then
         call help_makfil (link)
      elseif (link.eq.'maklib') then
         call help_maklib (link)
      elseif (link.eq.'makmat') then
         call help_makmat (link)  
      elseif (link.eq.'maksim') then
         call help_maksim (link)
      elseif (link.eq.'mmfit') then
         call help_mmfit (link) 
      elseif (link.eq.'normal') then
         call help_normal (link)
      elseif (link.eq.'polnom') then
         call help_polnom (link)
      elseif (link.eq.'qnfit') then
         call help_qnfit (link)   
      elseif (link.eq.'rannum') then
         call help_rannum (link)
      elseif (link.eq.'rffit') then
         call help_rffit (link)
      elseif (link.eq.'rstest') then
         call help_rstest (link)
      elseif (link.eq.'sffit') then
         call help_sffit (link)
      elseif (link.eq.'simplot') then
         call help_simplot (link)  
      elseif (link.eq.'simstat') then
         call help_simstat (link)
      elseif (link.eq.'spline') then
         call help_spline (link)  
      elseif (link.eq.'ttest') then
         call help_ttest (link)
      elseif (link.eq.'usermod') then
         call help_usermod (link)                                                          
      else   
c
c call main help dll
c
         call help_main (link)
      endif   
      end
c
c
C
C
      SUBROUTINE LCASE1 (STRNG)
C
C ACTION : Transform a string to lower case
C AUTHOR : W.G.Bardsley, University of manchester, U.K., 3/11/95
C          This version adds 32 instead of character conversion
C          16/12/1996 Modified for win32 
C          28/01/2007 added INTENT
C
      IMPLICIT   NONE 
C
C Argument
C             
      CHARACTER (LEN = *), INTENT (INOUT) :: STRNG 
C
C Locals
C      
      INTEGER    I, J
      INTEGER    N1, N32, N65, N90
      PARAMETER (N1 = 1, N32 = 32, N65 = 65, N90 = 90)
      INTRINSIC  CHAR, ICHAR, LEN
      DO I = N1, LEN(STRNG)
         J = ICHAR(STRNG(I:I))
         IF (J.GE.N65 .AND. J.LE.N90) STRNG(I:I) = CHAR(J + N32)
      ENDDO
      END
C
C
