
C
C SIMSTAT6.INS: Include file for SIMSTAT
C =============
C
C SUB006
C Date of this version 12/03/2006
C
C-----------------------------------------------------------------------
C
      SUBROUTINE SUB006 (NAMAX, NCSAV, NIN, NOUT, NRSAV,
     +                   FNAMEA, NO_DATA, NO_FILE, STOREA,
     +                   TITLEA)
C
C Regress
C
      IMPLICIT   NONE
C
C Arguments
C
      INTEGER    NAMAX
      INTEGER    NCSAV(NAMAX), NIN, NOUT, NRSAV(NAMAX)
      CHARACTER  FNAMEA(NAMAX)*(*), NO_DATA*(*),
     +           NO_FILE*(*), STOREA(NAMAX)*(*), TITLEA(NAMAX)*(*)
C
C Locals
C
      INTEGER    IX, IY, NUMDEC, NUMOPT, NTEXT
      PARAMETER (IX = 4, IY = 4, NUMOPT = 20, NTEXT = NUMOPT + 1)
      INTEGER    I, ISEND
      INTEGER    MTYPE
      PARAMETER (MTYPE = 3)
      CHARACTER  TEXT(NTEXT)*100
      CHARACTER  NAG5*5, PLS*5
      LOGICAL    TITLES
      PARAMETER (TITLES = .TRUE.)
      LOGICAL    REPEET
      LOGICAL    ASAMOD
      PARAMETER (ASAMOD = .FALSE.)
      EXTERNAL   STORE_A
      EXTERNAL   LVIEW2, REVPRO, TTEST2, PCVTS3, PLSFIT
      EXTERNAL   M_MATONE, M_GLMINI
      EXTERNAL   HELP_SIMSTAT
      NUMDEC = NUMOPT
      REPEET = .TRUE.
      DO WHILE (REPEET)
         CLOSE (UNIT = NIN)
         CALL STORE_A (NAMAX, NCSAV, NRSAV,
     +                 FNAMEA, NO_DATA, NO_FILE, STOREA, TITLEA)
            NAG5 = '     '
            PLS = '     '
         WRITE (TEXT,100) (STOREA(I), I = 15, 25),
     +                     STOREA(12), NAG5, PLS
         NUMDEC = NUMOPT - 1
         CALL LVIEW2 (IX, IY, NUMDEC, NUMOPT,
     +                TEXT, TITLES)
         IF (NUMDEC.GE.1 .AND. NUMDEC.LE.6) THEN
C
C Fit one of three line types in simple or advanced mode
C
            ISEND = NUMDEC + 14
            CALL M_MATONE (ISEND, NCSAV(ISEND), NIN, NOUT, NRSAV(ISEND),
     +                     FNAMEA(ISEND), TITLEA(ISEND))
         ELSEIF (NUMDEC.GE.7 .AND. NUMDEC.LT.11) THEN
C
C Fit one of various polynomial types
C
            ISEND = NUMDEC + 14
            CALL M_MATONE (ISEND, NCSAV(ISEND), NIN, NOUT, NRSAV(ISEND),
     +                     FNAMEA(ISEND), TITLEA(ISEND))
         ELSEIF (NUMDEC.EQ.11) THEN
C
C Multilinear regression
C
            ISEND = 25
            CALL M_MATONE (ISEND, NCSAV(ISEND), NIN, NOUT, NRSAV(ISEND),
     +                     FNAMEA(ISEND), TITLEA(ISEND))
         ELSEIF (NUMDEC.EQ.12) THEN
C
C Dose-response by GLM
C
            ISEND = 12
            CALL M_MATONE (ISEND, NCSAV(ISEND), NIN, NOUT, NRSAV(ISEND),
     +                     FNAMEA(ISEND), TITLEA(ISEND))
         ELSEIF (NUMDEC.EQ.13) THEN
C
C Logistic regression by GLM
C
            CALL M_GLMINI (MTYPE, NIN, NOUT)
         ELSEIF (NUMDEC.EQ.14) THEN
C
C Cox regression
C
            ISEND = 11
            CALL M_MATONE (ISEND, NCSAV(ISEND), NIN, NOUT, NRSAV(ISEND),
     +                     FNAMEA(ISEND), TITLEA(ISEND))
         ELSEIF (NUMDEC.EQ.15) THEN
C
C PLS
C         
            CALL PLSFIT (NIN, NOUT,
     +                   ASAMOD)            
         ELSEIF (NUMDEC.EQ.NUMOPT - 4) THEN
C
C Test two parameters
C
            CALL TTEST2 (NOUT)
         ELSEIF (NUMDEC.EQ.NUMOPT - 3) THEN
C
C Test two sets of parameters
C
            CALL PCVTS3 (NOUT)
         ELSEIF (NUMDEC.EQ.NUMOPT - 2) THEN
C
C Results
C
            CALL REVPRO (NOUT)
         ELSEIF (NUMDEC.EQ.NUMOPT - 1) THEN
C
C Help
C
            CALL HELP_SIMSTAT ('simstat')
         ELSEIF (NUMDEC.EQ.NUMOPT) THEN
C
C Cancel
C
            REPEET = .FALSE.
         ENDIF
         CLOSE (UNIT = NIN)
      ENDDO
  100 FORMAT (
     + 'The SIMSTAT linear regression options    `Data Type'
     +/'Fit a line (simple least squares)        `x,y,s data',1X,A
     +/'Fit a line (simple reduced major axis)   `x,y,s data',1X,A
     +/'Fit a line (simple orthogonal)           `x,y,s data',1X,A
     +/'Fit a line (advanced least squares)      `x,y,s data',1X,A
     +/'Fit a line (advanced reduced major axis) `x,y,s data',1X,A
     +/'Fit a line (advanced orthogonal)         `x,y,s data',1X,A
     +/'Fit a line/calibrate (simple)            `x,y,s data',1X,A
     +/'Fit a line/calibrate (advanced)          `x,y,s data',1X,A
     +/'Fit a polynomial/calibrate (x,y)         `x,y,s data',1X,A
     +/'Fit a polynomial/calibrate (g(x),f(y))   `x,y,s data',1X,A
     +/'Fit a multilinear model f(x1,x2,...,xn)  `',
     +'x1,x2,...,xn,y,s data',1X,A
     +/'Fit dose-response curves (LD50 by GLM)   `x,y,N,s data',1X,A
     +/'Fit logistic regression models (GLM)     `x,y,N,s data'
     +/'Fit Cox proportional hazards model       `',
     +'x1,x2,...,xn,y,t,s data',1X,A
     +/'Partial least squares (PLS)              `X,Y,Z matrices',1X,A
     +/'Compare 2 regression parameters          `p,se(p),npts,npar'
     +/'Compare 2 sets of regression parameters  `c_recent.cfg files'
     +/'Results                                  `...'
     +/'Help                                     `...'
     +/'Exit regression options                  `...')
      END
C
C --------------------------------------------------------------------
C
